/* Sistemas Integrados TECNISA
   Planejamento Alimentao Industrial

Nome: UTIL_CONSPLAN.SQL

Descrio:
Rotinas e cursores que ajudam no calculo do consumo planejado

Criao:
26/02/99 - Zed

Manutenes:
27/04/99 - Ederson - Corrigir o tipo dos parametros referentes ao
                     intervalo de produtos que nao podiam ser declarados
                     com o tipo da tabela, ou seja, VARCHAR2(10).
*/

   /* --- PROCEDURE QUE ATUALIZA A PREVRETI VERIFICANDO SE  NECESSARIA A --- */
   /* --------------------- INCLUSAO OU ALTERACAO --------------------------- */

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
	        O.NAME = 'ATUALIZA_PREVRETI'  AND
	        TYPE = 'P' 		      AND
	        U.UID = O.UID                 AND
	        U.NAME = USER)
DROP PROCEDURE ATUALIZA_PREVRETI
GO

CREATE PROCEDURE ATUALIZA_PREVRETI @P_CDFILIAL              VARCHAR(4),
                                   @CONS_REC_DTDATA         DATETIME,
                                   @CONS_REC_CDSERVFILI     VARCHAR(5),
                                   @CONS_REC_HRINICATEN     VARCHAR(4),
                                   @CONS_REC_NRCARDAPIO     VARCHAR(10),
                                   @CONS_REC_QTCOMESTICAR   NUMERIC(10,3),
                                   @CONS_REC_QTESTITURNO1   NUMERIC(10,3),
                                   @CONS_REC_QTESTITURNO2   NUMERIC(10,3),
                                   @CONS_REC_QTESTITURNO3   NUMERIC(10,3),
                                   @CONS_REC_QTESTITURNO4   NUMERIC(10,3),
                                   @P_IDPREVRETI   	    VARCHAR(1),
                                   @P_CDPRODUTO    	    VARCHAR(10),
                                   @P_DTLIMITERETI 	    DATETIME,
                                   @P_HRLIMITERETI 	    VARCHAR(4),
                                   @P_QTPREVRETI   	    NUMERIC(15,5),
                                   @P_QTPRERETT1   	    NUMERIC(15,5),
                                   @P_QTPRERETT2   	    NUMERIC(15,5),
                                   @P_QTPRERETT3   	    NUMERIC(15,5),
                                   @P_QTPRERETT4   	    NUMERIC(15,5),
                                   @P_AJUSHRLIMI   	    VARCHAR(1),
                                   @P_CDOPERADOR   	    VARCHAR(12),
                                   @P_IDUTREQUPRAT          VARCHAR(1),
                                   @P_CDTIPOPRAT            VARCHAR(2),
                                   @P_CDFILAUXPRAT          VARCHAR(4),
                                   @P_CDPRATO               VARCHAR(10),
				                   @P_VRPEFATCOR 	    NUMERIC(15,5),
				                   @P_QTBRUTAUNR        NUMERIC(15,5),
				                   @P_SGUNADICIONAL     VARCHAR(10)    


AS

   DECLARE @V_DTLIMITEPR  DATETIME;
   DECLARE @V_HRLIMITEPR  VARCHAR(4);
   DECLARE @V_CONTAUXI    NUMERIC;
   DECLARE @V_NRPRPREVRETI VARCHAR(4);

BEGIN
   SELECT
      @V_CONTAUXI = COUNT(*)
   FROM
      PREVRETI
   WHERE
      (CDFILIAL   = @P_CDFILIAL)          AND
      (CDSERVFILI = @CONS_REC_CDSERVFILI) AND
      (DTPREVRETI = @CONS_REC_DTDATA)     AND
      (NRREQUEXTR = '0000000000')         AND
      (IDPREVRETI = @P_IDPREVRETI)        AND
      (CDPRODUTO  = @P_CDPRODUTO)         AND
      (CDPRATO      = @P_CDPRATO)         AND
      (CDFILAUXPRAT = @P_CDFILAUXPRAT)    AND
      (CDTIPOPRAT   = @P_CDTIPOPRAT)   ;


   /* --------------- VERIFICA SE PRODUTO JA ESTA CADASTRADO ------------- */
   IF @V_CONTAUXI = 0
   BEGIN
      IF (@P_IDUTREQUPRAT <> 'S') BEGIN
         INSERT INTO PREVRETI
            (CDFILIAL,
             CDSERVFILI,
             DTPREVRETI,
             NRREQUEXTR,
             IDPREVRETI,
             CDPRODUTO,
             DTLIMITERETI,
             HRLIMITERETI,
             QTPREVRETI,
             QTPRERETT1,
             QTPRERETT2,
             QTPRERETT3,
             QTPRERETT4,
             QTPREVRETISA,
             QTPRERETT1SA,
             QTPRERETT2SA,
             QTPRERETT3SA,
             QTPRERETT4SA,
             CDOPERADOR,
	         VRPEFATCORRETI)
         VALUES
            (@P_CDFILIAL,
             @CONS_REC_CDSERVFILI,
             @CONS_REC_DTDATA,
             '0000000000',
             @P_IDPREVRETI,
             @P_CDPRODUTO,
             CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTLIMITERETI, 103), 103),
             @P_HRLIMITERETI,
             @P_QTPREVRETI,
             @P_QTPRERETT1,
             @P_QTPRERETT2,
             @P_QTPRERETT3,
             @P_QTPRERETT4,
             @P_QTPREVRETI,
             @P_QTPRERETT1,
             @P_QTPRERETT2,
             @P_QTPRERETT3,
             @P_QTPRERETT4,
             @P_CDOPERADOR,
	         @P_VRPEFATCOR);
      END;
      IF (@P_IDUTREQUPRAT = 'S') AND (NOT @P_CDTIPOPRAT IS NULL)
      BEGIN

         SELECT
            @V_NRPRPREVRETI = ISNULL(MAX(PR.NRPRPREVRETI), 0)
         FROM
            PREVRETI PR
         WHERE
            (PR.CDFILIAL     = @P_CDFILIAL)          AND
            (PR.CDSERVFILI   = @CONS_REC_CDSERVFILI) AND
            (PR.DTPREVRETI   = @CONS_REC_DTDATA)     AND
            (PR.IDPREVRETI   = @P_IDPREVRETI)        AND
            (PR.NRREQUEXTR   = '0000000000');

         SET @V_NRPRPREVRETI = RIGHT('0000'+CONVERT(VARCHAR(4),CONVERT(DOUBLE PRECISION, @V_NRPRPREVRETI) + 1), 4);

         INSERT INTO PREVRETI
            (CDFILIAL,
             CDSERVFILI,
             DTPREVRETI,
             NRREQUEXTR,
             IDPREVRETI,
             CDPRODUTO,
             DTLIMITERETI,
             HRLIMITERETI,
             QTPREVRETI,
             QTPRERETT1,
             QTPRERETT2,
             QTPRERETT3,
             QTPRERETT4,
             QTPREVRETISA,
             QTPRERETT1SA,
             QTPRERETT2SA,
             QTPRERETT3SA,
             QTPRERETT4SA,
             CDOPERADOR,
             CDTIPOPRAT,
             CDFILAUXPRAT,
             CDPRATO,
             IDPREVTPPRAT,
             NRPRPREVRETI,
	         VRPEFATCORRETI,
	         QTPREVBRUTAUNR,
	         SGPREVUNIADIC)
         VALUES
            (@P_CDFILIAL,
             @CONS_REC_CDSERVFILI,
             @CONS_REC_DTDATA,
             '0000000000',
             @P_IDPREVRETI,
             @P_CDPRODUTO,
             CONVERT(DATETIME,CONVERT(VARCHAR,@P_DTLIMITERETI,103),103),
             @P_HRLIMITERETI,
             @P_QTPREVRETI,
             @P_QTPRERETT1,
             @P_QTPRERETT2,
             @P_QTPRERETT3,
             @P_QTPRERETT4,
             @P_QTPREVRETI,
             @P_QTPRERETT1,
             @P_QTPRERETT2,
             @P_QTPRERETT3,
             @P_QTPRERETT4,
             @P_CDOPERADOR,
             @P_CDTIPOPRAT,
             @P_CDFILAUXPRAT,
             @P_CDPRATO,
             'S',
             @V_NRPRPREVRETI,
	         @P_VRPEFATCOR,
	         @P_QTBRUTAUNR,
	         @P_SGUNADICIONAL);
      END;
   END
   ELSE BEGIN

      UPDATE
         PREVRETI
      SET
         QTPREVRETI = QTPREVRETI + @P_QTPREVRETI,
         QTPRERETT1 = QTPRERETT1 + @P_QTPRERETT1,
         QTPRERETT2 = QTPRERETT2 + @P_QTPRERETT2,
         QTPRERETT3 = QTPRERETT3 + @P_QTPRERETT3,
         QTPRERETT4 = QTPRERETT4 + @P_QTPRERETT4,
         QTPREVRETISA = QTPREVRETI + @P_QTPREVRETI,
         QTPRERETT1SA = QTPRERETT1 + @P_QTPRERETT1,
         QTPRERETT2SA = QTPRERETT2 + @P_QTPRERETT2,
         QTPRERETT3SA = QTPRERETT3 + @P_QTPRERETT3,
         QTPRERETT4SA = QTPRERETT4 + @P_QTPRERETT4,
         QTPREVBRUTAUNR = QTPREVBRUTAUNR + @P_QTBRUTAUNR
      WHERE
         (CDFILIAL   = @P_CDFILIAL)          AND
         (CDSERVFILI = @CONS_REC_CDSERVFILI) AND
         (DTPREVRETI = @CONS_REC_DTDATA)     AND
         (NRREQUEXTR = '0000000000')         AND
         (IDPREVRETI = @P_IDPREVRETI)        AND
         (CDPRODUTO  = @P_CDPRODUTO)         AND
         (CDTIPOPRAT   = @P_CDTIPOPRAT)      AND
         (CDFILAUXPRAT = @P_CDFILAUXPRAT)    AND
         (CDPRATO      = @P_CDPRATO);

      /* ------------ EFETUA O AJUSTE DA DATA E HORA LIMITE -------------- */
      IF @P_AJUSHRLIMI = 'S'
      BEGIN
         SELECT
            @V_DTLIMITEPR = DTLIMITERETI,
            @V_HRLIMITEPR = HRLIMITERETI
         FROM
            PREVRETI
         WHERE
            (CDFILIAL   = @P_CDFILIAL)          AND
            (CDSERVFILI = @CONS_REC_CDSERVFILI) AND
            (DTPREVRETI = @CONS_REC_DTDATA)     AND
            (NRREQUEXTR = '0000000000')         AND
            (IDPREVRETI = @P_IDPREVRETI)        AND
            (CDPRODUTO  = @P_CDPRODUTO)         AND
            (CDTIPOPRAT   = @P_CDTIPOPRAT)      AND
            (CDFILAUXPRAT = @P_CDFILAUXPRAT)    AND
            (CDPRATO      = @P_CDPRATO);

         SET @V_DTLIMITEPR = CONVERT(DATETIME,(CONVERT(VARCHAR,@V_DTLIMITEPR, 103)+' '+SUBSTRING(@V_HRLIMITEPR, 1, 2)+':'+SUBSTRING(@V_HRLIMITEPR, 3, 2)),103);

         IF @P_DTLIMITERETI < @V_DTLIMITEPR
         BEGIN
            UPDATE
               PREVRETI
            SET
               DTLIMITERETI = CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTLIMITERETI, 103),103),
               HRLIMITERETI = @P_HRLIMITERETI
            WHERE
               (CDFILIAL   = @P_CDFILIAL)          AND
               (CDSERVFILI = @CONS_REC_CDSERVFILI) AND
               (DTPREVRETI = @CONS_REC_DTDATA)     AND
               (NRREQUEXTR = '0000000000')         AND
               (IDPREVRETI = @P_IDPREVRETI)        AND
               (CDPRODUTO  = @P_CDPRODUTO)         AND
               (CDTIPOPRAT   = @P_CDTIPOPRAT)      AND
               (CDFILAUXPRAT = @P_CDFILAUXPRAT)    AND
               (CDPRATO      = @P_CDPRATO);
         END;
      END; /* AJUSTE DE DATA HORA LIMITE */
   END; /* VERIFICAO DA EXISTENCIA DO PRODUTO */
END; /*ATUALIZA_PREVRETI*/
GO


   /* --- PROCEDURE QUE ATUALIZA A CONSPLAN VERIFICANDO SE  NECESSARIA A --- */
   /* --------------------- INCLUSAO OU ALTERACAO --------------------------- */
IF EXISTS(SELECT name FROM sysobjects
          WHERE name = 'ATUALIZA_CONSPLAN' AND type = 'P')
DROP PROCEDURE ATUALIZA_CONSPLAN
GO

CREATE PROCEDURE ATUALIZA_CONSPLAN
                            @P_NRCONSPLAN          VARCHAR(10),
                            @P_CDFILIAL            VARCHAR(4),
                            @CONS_REC_DTDATA       DATETIME,
                            @CONS_REC_CDSERVFILI   VARCHAR(5),
                            @CONS_REC_HRINICATEN   VARCHAR(4),
                            @CONS_REC_NRCARDAPIO   VARCHAR(10),
                            @CONS_REC_CDCLIENTE    VARCHAR(21),
                            @CONS_REC_CDDESTFILI   VARCHAR(3),
                            @CONS_REC_QTCOMESTICAR NUMERIC(10,3),
                            @CONS_REC_QTESTITURNO1 NUMERIC(10,3),
                            @CONS_REC_QTESTITURNO2 NUMERIC(10,3),
                            @CONS_REC_QTESTITURNO3 NUMERIC(10,3),
                            @CONS_REC_QTESTITURNO4 NUMERIC(10,3),
                            @P_IDCONSPLAN      	   VARCHAR(1),
                            @P_CDFAPRATCPLA    	   VARCHAR(4),
                            @P_CDPRATCONSPL        VARCHAR(10),
                            @P_CDAPRECONSPL        VARCHAR(3),
                            @P_CDSETOCONSPL        VARCHAR(2),
                            @P_CDPRODCPLA          VARCHAR(10),
                            @P_DTLIMITECPLA    	   DATETIME,
                            @P_HRLIMITECPLA    	   VARCHAR(4),
                            @P_CDTPPRATCPLA    	   VARCHAR(2),
                            @P_QTCONSPLAN      	   NUMERIC(15,5),
                            @P_QTCONSPLANT1    	   NUMERIC(15,5),
                            @P_QTCONSPLANT2    	   NUMERIC(15,5),
                            @P_QTCONSPLANT3    	   NUMERIC(15,5),
                            @P_QTCONSPLANT4    	   NUMERIC(15,5),
                            @P_VRPECONSPLAN    	   FLOAT,
                            @P_QTCOMESTCPLA    	   NUMERIC(10,3),
                            @P_AJUSHRLIMI      	   VARCHAR(1),
                            @P_QTCOMPLPRODCPLA     NUMERIC (15,5),
			                @P_VRPEFATCOR  	       NUMERIC(15,5),
			                @P_QTBRUTAUNR          NUMERIC(15,5),
			                @P_SGUNADICIONAL       VARCHAR(10)
AS
   DECLARE @V_DTLIMITEPR   DATETIME;
   DECLARE @V_HRLIMITEPR   VARCHAR(4);
   DECLARE @V_CONTAUXI     NUMERIC;
   DECLARE @V_QTCOMESTCPLA NUMERIC(10,3);
   DECLARE @V_QTCONSPLAN   NUMERIC(15,5);
   DECLARE @V_QTCONSPLANT1 NUMERIC(15,5);
   DECLARE @V_QTCONSPLANT2 NUMERIC(15,5);
   DECLARE @V_QTCONSPLANT3 NUMERIC(15,5);
   DECLARE @V_QTCONSPLANT4 NUMERIC(15,5);
   DECLARE @V_QTCOMPLPRODCPLA NUMERIC (15,5);
   DECLARE @V_QTBRUTAUNR   NUMERIC(15,5);
BEGIN

   SET @V_CONTAUXI = 0;
   SET @V_QTCOMESTCPLA = @P_QTCOMESTCPLA;

   IF @V_QTCOMESTCPLA = 0
   BEGIN
      SET @V_QTCOMESTCPLA = 1;
   END;

   SELECT
      @V_CONTAUXI = COUNT(*)
   FROM
      CONSPLAN
   WHERE
      (NRCONSPLAN   = @P_NRCONSPLAN)          AND
      (CDFILICPLA   = @P_CDFILIAL)            AND
      (CDSERVCPLA   = @CONS_REC_CDSERVFILI)   AND
      (DTCONSPLAN   = @CONS_REC_DTDATA)       AND
      (IDCONSPLAN   = @P_IDCONSPLAN)          AND
      (CDFAPRATCPLA = @P_CDFAPRATCPLA)        AND
      (CDTPPRATCPLA = @P_CDTPPRATCPLA)        AND
      (CDPRATCONSPL = @P_CDPRATCONSPL)        AND
      (CDPRODCPLA   = @P_CDPRODCPLA)          AND
      (CDCLIECPLA   = @CONS_REC_CDCLIENTE)    AND
      (CDDESTFICPLA = @CONS_REC_CDDESTFILI);
   /* --------------- VERIFICA SE PRODUTO JA ESTA CADASTRADO ------------- */
   IF @V_CONTAUXI = 0 BEGIN
      INSERT INTO CONSPLAN
         (NRCONSPLAN,
          CDFILICPLA,
          CDSERVCPLA,
          DTCONSPLAN,
          IDCONSPLAN,
          CDFAPRATCPLA,
          CDPRATCONSPL,
          CDAPRECONSPL,
          CDSETOCONSPL,
          CDPRODCPLA,
          DTLIMITECPLA,
          HRLIMITECPLA,
          CDTPPRATCPLA,
          CDCLIECPLA,
          CDDESTFICPLA,
          QTCONSPLAN,
          QTCONSPLANT1,
          QTCONSPLANT2,
          QTCONSPLANT3,
          QTCONSPLANT4,
          QTCONSPLANSA,
          QTCONPLAT1SA,
          QTCONPLAT2SA,
          QTCONPLAT3SA,
          QTCONPLAT4SA,
          VRPECONSPLAN,
          QTCOMESTCPLA,
	      VRPEFATCORCONS,
	      QTCONSBRUTAUNR,
	      SGCONSUNIADIC
	      )
      VALUES
         (@P_NRCONSPLAN,
          @P_CDFILIAL,
          @CONS_REC_CDSERVFILI,
          @CONS_REC_DTDATA,
          @P_IDCONSPLAN,
          @P_CDFAPRATCPLA,
          @P_CDPRATCONSPL,
          @P_CDAPRECONSPL,
          @P_CDSETOCONSPL,
          @P_CDPRODCPLA,
          CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTLIMITECPLA, 103), 103),
          @P_HRLIMITECPLA,
          @P_CDTPPRATCPLA,
          @CONS_REC_CDCLIENTE,
          @CONS_REC_CDDESTFILI,
          @P_QTCONSPLAN,
          @P_QTCONSPLANT1,
          @P_QTCONSPLANT2,
          @P_QTCONSPLANT3,
          @P_QTCONSPLANT4,
          @P_QTCONSPLAN,
          @P_QTCONSPLANT1,
          @P_QTCONSPLANT2,
          @P_QTCONSPLANT3,
          @P_QTCONSPLANT4,
          @P_VRPECONSPLAN,
          @V_QTCOMESTCPLA,
	      @P_VRPEFATCOR,
	      @P_QTBRUTAUNR,
	      @P_SGUNADICIONAL);

   END
   ELSE BEGIN /* SOMA A QUANTIDADE */
      IF (@P_IDCONSPLAN = 'F') BEGIN
         SET @V_QTCONSPLAN   = 0;
         SET @V_QTCONSPLANT1 = 0;
         SET @V_QTCONSPLANT2 = 0;
         SET @V_QTCONSPLANT3 = 0;
         SET @V_QTCONSPLANT4 = 0;
         SET @V_QTCOMPLPRODCPLA = 0
         SET @V_QTBRUTAUNR = 0;   
      END
      ELSE BEGIN
         SET @V_QTCONSPLAN   =  @P_QTCONSPLAN;
         SET @V_QTCONSPLANT1 =  @P_QTCONSPLANT1;
         SET @V_QTCONSPLANT2 =  @P_QTCONSPLANT2;
         SET @V_QTCONSPLANT3 =  @P_QTCONSPLANT3;
         SET @V_QTCONSPLANT4 =  @P_QTCONSPLANT4;
         SET @V_QTCOMPLPRODCPLA = @P_QTCOMPLPRODCPLA;
         SET @V_QTBRUTAUNR = @P_QTBRUTAUNR;    
      END;

      UPDATE CONSPLAN
      SET
         QTCONSPLAN   = QTCONSPLAN   + @V_QTCONSPLAN,
         QTCONSPLANT1 = QTCONSPLANT1 + @V_QTCONSPLANT1,
         QTCONSPLANT2 = QTCONSPLANT2 + @V_QTCONSPLANT2,
         QTCONSPLANT3 = QTCONSPLANT3 + @V_QTCONSPLANT3,
         QTCONSPLANT4 = QTCONSPLANT4 + @V_QTCONSPLANT4,
         QTCONSPLANSA = QTCONSPLAN   + @V_QTCONSPLAN,
         QTCONPLAT1SA = QTCONSPLANT1 + @V_QTCONSPLANT1,
         QTCONPLAT2SA = QTCONSPLANT2 + @V_QTCONSPLANT2,
         QTCONPLAT3SA = QTCONSPLANT3 + @V_QTCONSPLANT3,
         QTCONPLAT4SA = QTCONSPLANT4 + @V_QTCONSPLANT4,
         QTCOMPLPRODCPLA = QTCOMPLPRODCPLA + @V_QTCOMPLPRODCPLA,
         QTCONSBRUTAUNR = QTCONSBRUTAUNR + @V_QTBRUTAUNR      
      WHERE
         (NRCONSPLAN   = @P_NRCONSPLAN)              AND
         (CDFILICPLA   = @P_CDFILIAL)                AND
         (CDSERVCPLA   = @CONS_REC_CDSERVFILI)       AND
         (DTCONSPLAN   = @CONS_REC_DTDATA)           AND
         (IDCONSPLAN   = @P_IDCONSPLAN)              AND
         (CDFAPRATCPLA = @P_CDFAPRATCPLA)            AND
         (CDPRATCONSPL = @P_CDPRATCONSPL)            AND
         (CDTPPRATCPLA = @P_CDTPPRATCPLA)            AND
         (CDPRODCPLA   = @P_CDPRODCPLA)              AND
         (CDCLIECPLA   = @CONS_REC_CDCLIENTE)        AND
         (CDDESTFICPLA = @CONS_REC_CDDESTFILI);

      /* ------------ EFETUA O AJUSTE DA DATA E HORA LIMITE -------------- */
      IF @P_AJUSHRLIMI = 'S'
      BEGIN
         SET @V_DTLIMITEPR = CONVERT(DATETIME, (CONVERT(VARCHAR, @P_DTLIMITECPLA, 103)+' '+SUBSTRING(@P_HRLIMITECPLA, 1, 2)+':'+SUBSTRING(@P_HRLIMITECPLA, 3, 2)), 103);
         IF @P_DTLIMITECPLA < @V_DTLIMITEPR
         BEGIN

            UPDATE CONSPLAN
            SET
               DTLIMITECPLA = CONVERT(DATETIME, CONVERT(VARCHAR, @P_DTLIMITECPLA, 103), 103),
               HRLIMITECPLA = @P_HRLIMITECPLA
            WHERE
               (NRCONSPLAN   = @P_NRCONSPLAN)        AND
               (CDFILICPLA   = @P_CDFILIAL)          AND
               (CDSERVCPLA   = @CONS_REC_CDSERVFILI) AND
               (DTCONSPLAN   = @CONS_REC_DTDATA)     AND
               (IDCONSPLAN   = @P_IDCONSPLAN)        AND
               (CDFAPRATCPLA = @P_CDFAPRATCPLA)      AND
               (CDPRATCONSPL = @P_CDPRATCONSPL)      AND
               (CDTPPRATCPLA = @P_CDTPPRATCPLA)      AND
               (CDPRODCPLA   = @P_CDPRODCPLA);

         END;
      END; /* AJUSTE DE DATA HORA LIMITE */
   END; /* VERIFICAO DA EXISTENCIA DO PRODUTO */
END; /*ATUALIZA_CONSPLAN*/
GO


-- VERSAO --
EXEC ATUVEROBJ 'ATUALIZA_CONSPLAN','4.09.068';
GO






   
    
