/*

@C:\web_511\sql\end_conv\oracle\9341_CVISTPO_ETL_MERENDA.SQL


- Erro     : raise_application_error(-20501, 'Mensagem', True);
*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
                    WHERE
                       O.NAME = 'ETL_MERENDA'  AND
                       TYPE = 'P'                  AND
                       U.UID = O.UID               AND
                       U.NAME = USER)

   DROP PROCEDURE ETL_MERENDA
   GO


CREATE PROCEDURE ETL_MERENDA @P_DTINI DATETIME,
                              @P_DTFINA DATETIME
AS
   DECLARE @V_CDFILIAL	       VARCHAR(4);			
   DECLARE @V_CDAREAGERE      VARCHAR(03);
   DECLARE @V_CDSUPERVISOR    VARCHAR(12);
   DECLARE @V_CDGOPERAC       VARCHAR(12);
   DECLARE @V_CDSEGMER        VARCHAR(05);
   DECLARE @V_CDEMPRESA       VARCHAR(12);
   DECLARE @V_DTINICIALBI     DATETIME;
   DECLARE @V_DTPROCESSA      DATETIME;
   DECLARE @V_IDCOMCUSPERC    VARCHAR(1);

   DECLARE @V_COUNTER          FLOAT;
   DECLARE @V_DTFIM            DATETIME;
   DECLARE @V_DTINI            DATETIME;

   DECLARE @V_NRTIPOCUSTO1     FLOAT;
   DECLARE @V_NRTIPOCUSTO2     FLOAT;
   DECLARE @V_NRTIPOCUSTO3     FLOAT;

   DECLARE @V_VRCUSTPADR       FLOAT;
   DECLARE @V_ZERO             FLOAT;
   DECLARE @V_CDSEQUENCIAL     VARCHAR(20);
   DECLARE @V_COUNTTPCUST      FLOAT;

   DECLARE @V_MES              VARCHAR(02);
   DECLARE @V_ANO              VARCHAR(04);
   DECLARE @V_BIM              VARCHAR(06);
   DECLARE @V_TRI              VARCHAR(06);
   DECLARE @V_SEM              VARCHAR(06);
   DECLARE @V_CDTIPOCUSTO      VARCHAR(02); 
   DECLARE @w_S                CHAR;
   DECLARE @w_N                CHAR;
   DECLARE @V_LINHA           INTEGER;
   DECLARE @V_NRTIPOCUSTO      INTEGER;

/*   -----VARIAVEIS CURSOR C_SERVICO-----*/
   DECLARE @V_CDSERVFILI     VARCHAR(12);
   DECLARE @V_CDGRUPSERV     VARCHAR(12);
   DECLARE @V_QTCOMESTICAR   DOUBLE PRECISION;
   DECLARE @V_QTCOMEFETCAR   DOUBLE PRECISION;

   DECLARE @V_CUSTOPLAN        DOUBLE PRECISION;
   DECLARE @V_CUSTOPLAN1       DOUBLE PRECISION;
   DECLARE @V_CUSTOPLAN2       DOUBLE PRECISION;
   DECLARE @V_CUSTOPLAN3       DOUBLE PRECISION;

   DECLARE @V_CUSTOREAL        DOUBLE PRECISION;
   DECLARE @V_CUSTOREAL1       DOUBLE PRECISION;
   DECLARE @V_CUSTOREAL2       DOUBLE PRECISION;
   DECLARE @V_CUSTOREAL3       DOUBLE PRECISION;
   DECLARE @V_CUSTOPLANCENT    DOUBLE PRECISION;
   DECLARE @V_CUSTOPLANCENT1   DOUBLE PRECISION;
   DECLARE @V_CUSTOPLANCENT2   DOUBLE PRECISION;
   DECLARE @V_CUSTOPLANCENT3   DOUBLE PRECISION;
   DECLARE @V_CUSTOREALCENT    DOUBLE PRECISION;
   DECLARE @V_CUSTOREALCENT1   DOUBLE PRECISION;
   DECLARE @V_CUSTOREALCENT2   DOUBLE PRECISION;
   DECLARE @V_CUSTOREALCENT3   DOUBLE PRECISION;
   DECLARE @V_CDPRODUTO        VARCHAR(20);

   DECLARE @V_STR1	       VARCHAR(200);
   DECLARE @V_STR2	       VARCHAR(200);
   DECLARE @V_CDFILCENTPME    VARCHAR(4);
BEGIN
   SET @V_COUNTTPCUST = 0;
   SET @w_S  = 'S';
   SET @w_N  = 'N';

   SET @V_MES  =  (CONVERT (VARCHAR, MONTH (@P_DTINI)));
   SET @V_ANO  =  (CONVERT (VARCHAR, YEAR  (@P_DTINI)));

   BEGIN TRANSACTION;

   DELETE FROM ETL_RESUSERV
   WHERE (CDANOBI > @V_ANO)
      OR (CDANOBI = @V_ANO AND CDMESBI >= @V_MES);

   DELETE FROM ETL_RESUFOOD
   WHERE (CDANOBI > @V_ANO)
      OR (CDANOBI = @V_ANO AND CDMESBI >= @V_MES);

   COMMIT TRANSACTION;
  /* IF NOT CUSTO DIMENSAO*/
   /*ANALIZA SE EXISTE TPCUST CADASTRADO NA TABELA DIMENSAODW */
   SELECT
     @V_COUNTTPCUST =   COUNT(*)
   FROM
    DIMENSAODW
   WHERE
    CDTABELADW = 'ETL_RESUFOOD'
    AND CDITEMDIME = 'CDTIPOCUSTO';

   IF @V_COUNTTPCUST = 0 BEGIN

      DECLARE C_NRTPCUS CURSOR FOR
          SELECT  NRTIPOCUSTO
          FROM(SELECT CONVERT(FLOAT,CDTIPOCUSTO) NRTIPOCUSTO
          FROM   TIPOCUSTO
          WHERE IDTPCUSTOGSC = 'S')A
          ORDER BY NRTIPOCUSTO

      OPEN C_NRTPCUS;
      SET @V_LINHA = 1;

      FETCH NEXT FROM C_NRTPCUS INTO @V_NRTIPOCUSTO;

      WHILE (@@FETCH_STATUS = 0) BEGIN
         IF @V_LINHA    = 1 BEGIN
            SET @V_NRTIPOCUSTO1    = @V_NRTIPOCUSTO;
            SET @V_LINHA = 2;
         END;
         IF @V_LINHA = 2 BEGIN
            SET @V_NRTIPOCUSTO2    = @V_NRTIPOCUSTO;
            SET @V_LINHA = 3;
         END;
         IF @V_LINHA = 3 BEGIN
            SET @V_NRTIPOCUSTO3    = @V_NRTIPOCUSTO;
         END;
         FETCH NEXT FROM C_NRTPCUS INTO @V_NRTIPOCUSTO;
      END;
      CLOSE C_NRTPCUS;
      DEALLOCATE C_NRTPCUS;

      SET @V_DTINI = CONVERT(DATETIME,('01/'+@V_MES+'/'+@V_ANO),103);


      WHILE (@V_DTINI  <=  @P_DTFINA) BEGIN

         BEGIN TRANSACTION;

         SET @V_DTFIM =  DATEADD(MM, 1,@V_DTINI);
         SET @V_DTFIM =  DATEADD(DD,-1,@V_DTFIM);

         SET @V_MES  =  (CONVERT (VARCHAR, MONTH (@V_DTFIM)));
         SET @V_ANO  =  (CONVERT (VARCHAR, YEAR  (@V_DTFIM)));


         SET @V_BIM        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 2) + 1);
         SET @V_TRI        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 3) + 1);
         SET @V_SEM        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 6) + 1);


         DECLARE C_ETL CURSOR FOR
            SELECT FL.CDFILIAL,        FL.CDAREAGERE,          FL.DTINICIALBI,
                    FL.CDSUPERVISOR,    FL.CDGOPERAC,           FL.CDEMPRESA,
                    FL.CDSEGMER , FL.CDFILCENTPME
               FROM FILIAL FL, PARAMFILIAL P
              WHERE P.CDFILIAL = FL.CDFILIAL
                AND FL.IDFUNCAOFILI IS NULL
                AND FL.DTINICIALBI  IS NOT NULL
               and ISNULL(IDCTRLESTQ, @w_S) <> @w_N
               AND ISNULL(IDCNTRRESC, @w_N) <> @w_S
               ORDER BY FL.CDFILIAL

         OPEN C_ETL;
         FETCH NEXT FROM C_ETL INTO
                             @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                             @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                             @V_CDSEGMER, @V_CDFILCENTPME

         WHILE (@@FETCH_STATUS = 0) BEGIN

            IF (CONVERT (DATETIME, ('01' + '/' + CONVERT(VARCHAR, MONTH(@V_DTINICIALBI))+'/'+ CONVERT (VARCHAR, YEAR(@V_DTINICIALBI)))) <= @V_DTINI) BEGIN
               SET @V_STR1 = 'CONSPLAN'+@V_CDFILIAL;
               EXEC TEKNISA.NOVO_CODIGO @V_STR1, @V_CDSEQUENCIAL,1;
               SET @V_CDSEQUENCIAL = SUBSTRING(@V_CDSEQUENCIAL,11,10);

               SET @V_STR1 = ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTINI), 112) + '_');
               SET @V_STR1 = ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTFIM), 112) + '_');

               EXEC TEKNISA.CONSUMO_PLANEJADO_PLA
                                     @V_CDFILIAL,
                                     'T',
                                     @V_DTINI,
                                     @V_DTFIM,
                                     'T',
                                     'CFP',
                                     'N',
                                      0,
                                     'N',
                                     @V_CDSEQUENCIAL,
                                     '0',
                                     'zzzzzzzzzz',
                                     '',
                                     @V_STR1,
                                     @V_STR1;

               DECLARE C_SERVICO CURSOR FOR
                     SELECT
                            SE.CDSERVFILI,                 SE.CDGRUPSERV,
                            SUM(SE.QTCOMESTICAR / TOTAL) AS QTCOMESTICAR,
                            SUM(SE.QTCOMEFETCAR / TOTAL) AS QTCOMEFETCAR
                       FROM (SELECT
                                  CP.DTCONSPLAN DTCARDAPIO,
                                  SRV.CDSERVFILI, GS.CDGRUPSERV,
                                  SUM(CAR.QTCOMESTICAR) QTCOMESTICAR,
                                  SUM(CAR.QTCOMEFETCAR) QTCOMEFETCAR,
                                  COUNT(*) AS TOTAL
                             FROM  CARDADIA CAR, CONSPLAN CP, SERVICO SRV LEFT JOIN GRUPSERV GS ON
                                                               GS.CDGRUPSERV =   SRV.CDGRUPSERV
                             WHERE  CAR.CDFILIAL       =   SRV.CDFILIAL
                              AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   @V_CDFILIAL
                              AND CAR.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                              AND CP.CDFILICPLA      =   @V_CDFILIAL
                              AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                              AND CP.DTCONSPLAN      =   CAR.DTCARDAPIO
                              AND CP.NRCONSPLAN      =   @V_CDSEQUENCIAL
                            GROUP BY CP.DTCONSPLAN, SRV.CDSERVFILI,  SRV.CDFILIAL,  GS.CDGRUPSERV

                            UNION ALL

                             SELECT
                                  CAR.DTCARDAPIO,
                                  SRV.CDSERVFILI, GS.CDGRUPSERV,
                                  ISNULL(SUM(CAR.QTCOMESTICAR), 0) QTCOMESTICAR,
                                  ISNULL(SUM(CAR.QTCOMEFETCAR), 0) QTCOMEFETCAR,
                                  COUNT(*) AS TOTAL
                             FROM CARDADIA CAR, SERVICO SRV LEFT JOIN GRUPSERV GS ON
                                                        GS.CDGRUPSERV  =   SRV.CDGRUPSERV
                             WHERE CAR.CDFILIAL       =   SRV.CDFILIAL
                              AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   @V_CDFILIAL
                              AND CAR.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                              AND CAR.QTCOMESTICAR = 0
                              AND CAR.CDSERVFILI  NOT IN (SELECT CDSERVCPLA
                                                           FROM CONSPLAN CP
                                                         WHERE  CP.DTCONSPLAN BETWEEN @V_DTINI AND @V_DTFIM
                                                           AND  CP.DTCONSPLAN = CAR.DTCARDAPIO
                                                           AND  CP.NRCONSPLAN = @V_CDSEQUENCIAL
                                                           AND  CP.CDFILICPLA = @V_CDFILIAL)
                            GROUP BY CAR.DTCARDAPIO,SRV.CDSERVFILI, SRV.CDFILIAL, GS.CDGRUPSERV

                            UNION ALL
                                            /*QUANTIDADE PLANEJADA MERENDA*/
                            SELECT
                                   CD.DTCARDAPIO,
                                   SRV.CDSERVFILI, GS.CDGRUPSERV,
                                   SUM(CD.QTCOMESTICAR) QTCOMESTICAR,
                                   SUM(QTCLIESTICAR) QTCOMEFETCAR,
                                   COUNT(*) AS TOTAL
                              FROM  CONSPLAN CP,
                                   (SELECT  CDFILCENTPME, CDFILIAL, CDSERVFILI, DTCARDIAPME DTCARDAPIO, NRCARDPME,
                                      SUM(QTCOMESTCPME) QTCOMESTICAR, SUM(QTCLIESTCPME) QTCLIESTICAR
                                    FROM CARDIAPME
                                    WHERE
                                       CDFILCENTPME = @V_CDFILIAL  AND
                                       CDFILIAL = @V_CDFILIAL  AND
                                      (DTCARDIAPME BETWEEN @V_DTINI AND @V_DTFIM)
                                    GROUP BY CDFILCENTPME, CDFILIAL, CDSERVFILI, DTCARDIAPME, NRCARDPME) CD,
                                    SERVICO SRV LEFT JOIN GRUPSERV GS ON
                                       GS.CDGRUPSERV =   SRV.CDGRUPSERV
                              WHERE CD.CDFILIAL       =   SRV.CDFILIAL
                              AND CD.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   @V_CDFILIAL
                              AND CD.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                              AND CP.CDFILICPLA      =   @V_CDFILIAL
                              AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                              AND CP.DTCONSPLAN      =   CD.DTCARDAPIO
                              AND CP.NRCONSPLAN      =   @V_CDSEQUENCIAL
                              GROUP BY CD.DTCARDAPIO, SRV.CDSERVFILI, SRV.CDFILIAL, GS.CDGRUPSERV)SE
                       GROUP BY SE.CDSERVFILI, SE.CDGRUPSERV

               OPEN C_SERVICO;
               FETCH NEXT FROM C_SERVICO INTO @V_CDSERVFILI, @V_CDGRUPSERV, @V_QTCOMESTICAR, @V_QTCOMEFETCAR;

               WHILE (@@FETCH_STATUS = 0) BEGIN

                     SELECT @V_VRCUSTPADR = MAX(VRCUSTPADR)
                     FROM CUSTPADR
                     WHERE CDFILIAL     = @V_CDFILIAL
                       AND CDSERVFILI   = @V_CDSERVFILI
                       AND DTREFCUSPADR = (SELECT MAX(DTREFCUSPADR)
                                             FROM   CUSTPADR
                                             WHERE  CDFILIAL      = @V_CDFILIAL
                                               AND  CDSERVFILI    = @V_CDSERVFILI
                                               AND  DTREFCUSPADR <= @V_DTFIM);

                        DECLARE C_PRODUTO CURSOR FOR
                           SELECT SUM(PR.CUSTOPLAN1)  CUSTOPLAN1,
                               SUM(PR.CUSTOPLAN2)  CUSTOPLAN2,
                               SUM(PR.CUSTOPLAN3)  CUSTOPLAN3,
                               SUM(PR.CUSTOREAL1)  CUSTOREAL1,
                               SUM(PR.CUSTOREAL2)  CUSTOREAL2,
                               SUM(PR.CUSTOREAL3)  CUSTOREAL3,
                               SUM(PR.CUSTOPLANCENT1)  CUSTOPLANCENT1,
                               SUM(PR.CUSTOPLANCENT2)  CUSTOPLANCENT2,
                               SUM(PR.CUSTOPLANCENT3)  CUSTOPLANCENT3,
                               SUM(PR.CUSTOREALCENT1)  CUSTOREALCENT1,
                               SUM(PR.CUSTOREALCENT2)  CUSTOREALCENT2,
                               SUM(PR.CUSTOREALCENT3)  CUSTOREALCENT3,
                               PR.CDPRODUTO
                           FROM SERVICO SVC,
                               ( SELECT
                                    CP.CDFILICPLA CDFILIAL,
                                    CP.CDSERVCPLA CDSERVFILI,
                                    (CASE @V_NRTIPOCUSTO1 WHEN
                                           NULL THEN  NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO( CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO1,
                                              (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN)END) AS CUSTOPLAN1,

                                    (CASE @V_NRTIPOCUSTO2 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO2,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN)END) AS CUSTOPLAN2,

                                    (CASE @V_NRTIPOCUSTO3 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO (CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO3,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) END) AS CUSTOPLAN3,

                                    (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END) AS CUSTOREAL1,
                                    (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END) AS CUSTOREAL2,
                                    (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END) AS CUSTOREAL3,

                                    (CASE @V_NRTIPOCUSTO1 WHEN
                                           NULL THEN  NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO (@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO1,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN)END) AS CUSTOPLANCENT1,

                                    (CASE @V_NRTIPOCUSTO2 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO(@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO2,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) END) AS CUSTOPLANCENT2,

                                    (CASE @V_NRTIPOCUSTO3 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO(@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO3,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN)END) AS CUSTOPLANCENT3,

                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT3,

                                    CP.CDPRODCPLA CDPRODUTO
                                FROM
                                    CONSPLAN CP, PARAMGERAL PG,
                                    (SELECT  CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD, MAX(CM.DTREFECUSTMES) DTREFECUSTMES
                                     FROM    CARDADIA CD, CARDAMES CM
                                     WHERE   CD.CDFILIAL       =    @V_CDFILIAL       AND
                                             CD.CDSERVFILI     =    @V_CDSERVFILI AND
                                             CD.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM   AND
                                             (CD.CDFILIAL   = CM.CDFILIAL     ) AND
                                             (CD.CDSERVFILI = CM.CDSERVFILI   ) AND
                                             (CD.DTMESCARD  = CM.DTMESCARDAPIO)
                                     GROUP BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD) CD
                                WHERE
                                    CP.CDFILICPLA   =  @V_CDFILIAL              AND
                                    CP.NRCONSPLAN   =  @V_CDSEQUENCIAL              AND
                                    CD.CDFILIAL     =  CP.CDFILICPLA               AND
                                    CD.CDSERVFILI   =  CP.CDSERVCPLA               AND
                                    PG.CDPARGERAL   = '0001'                       AND
                                    CD.DTMESCARD    = CONVERT (DATETIME, ('01' + '/' + CONVERT(VARCHAR, MONTH(CP.DTCONSPLAN))+'/'+ CONVERT (VARCHAR,YEAR(CP.DTCONSPLAN))))

                                UNION ALL

                                SELECT
                                    H.CDFILIAL,
                                    H.CDSERVFILI,
                                    ((CASE @V_NRTIPOCUSTO1 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5)END)) AS CUSTOPLAN1,

                                    ((CASE @V_NRTIPOCUSTO2 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5)END)) AS CUSTOPLAN2,

                                    ((CASE @V_NRTIPOCUSTO3 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5)END)) AS CUSTOPLAN3,

                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREAL1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREAL2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREAL3,
                                                              /*CLCULO DA CENTRAL*/
                                    ((CASE @V_NRTIPOCUSTO1 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5)END)) AS CUSTOPLANCENT1,

                                    ((CASE @V_NRTIPOCUSTO2 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5)END)) AS CUSTOPLANCENT2,

                                    ((CASE @V_NRTIPOCUSTO3 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5) END)) AS CUSTOPLANCENT3,

                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT3,

                                    CNE.CDPRODUTO AS CDPRODUTO
                                FROM
                                    (
                                    SELECT
                                        CDR.CDFILIAL,   CDR.CDSERVFILI,  CDR.DTMESCARD,
                                        SUM(QTCOMESTICAR) AS TOTCOMEN
                                     FROM
                                        CARDADIA CDR
                                     WHERE
                                        (CDR.CDFILIAL         =   @V_CDFILIAL   ) AND
                                        (CDR.CDSERVFILI       =   @V_CDSERVFILI ) AND
                                        (CDR.DTCARDAPIO BETWEEN   @V_DTINI AND @V_DTFIM )
                                     GROUP BY
                                        CDSERVFILI, CDR.CDFILIAL, CDR.CDSERVFILI, CDR.DTMESCARD) H,
                                    RATENESTO RNE,
                                    CUSTNESTO CNE,
                                    CARDADIA  CD
                                WHERE
                                    (CD.CDFILIAL      =    @V_CDFILIAL         )   AND
                                    (H.CDFILIAL       =    @V_CDFILIAL         )   AND
                                    (CNE.CDFILIAL     =    @V_CDFILIAL         )   AND
                                    (RNE.CDFILIAL     =    @V_CDFILIAL         )   AND
                                    (CD.CDSERVFILI    =    @V_CDSERVFILI   )   AND
                                    (H.CDSERVFILI     =    @V_CDSERVFILI   )   AND
                                    (RNE.CDSERVFILI   =    @V_CDSERVFILI   )   AND
                                    (CNE.CDPRODUTO    =    RNE.CDPRODUTO           )   AND
                                    (CD.DTMESCARD     =    H.DTMESCARD             )   AND
                                    (CD.DTCARDAPIO BETWEEN   @V_DTINI AND @V_DTFIM )   AND
                                    (NOT H.TOTCOMEN IS NULL AND H.TOTCOMEN <> 0    )

                                UNION ALL

         ------------------------------------------------/* CUSTO PLANEJADO MERENDA */
                                 SELECT
                                    CP.CDFILICPLA CDFILIAL,
                                    CP.CDSERVCPLA CDSERVFILI,
                                    (CASE @V_NRTIPOCUSTO1 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO( CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO1,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN)END ) AS CUSTOPLAN1,

                                    (CASE @V_NRTIPOCUSTO2 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO( CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO2,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) END) AS CUSTOPLAN2,

                                    (CASE @V_NRTIPOCUSTO3 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO (CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO3,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) END) AS CUSTOPLAN3,

                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREAL1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREAL2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREAL3,

                                                              /*CLCULO DA CENTRAL*/
                                    (CASE @V_NRTIPOCUSTO1 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO (@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO1,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN)END ) AS CUSTOPLANCENT1,

                                    (CASE @V_NRTIPOCUSTO2 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO (@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO2,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN)END) AS CUSTOPLANCENT2,

                                    (CASE @V_NRTIPOCUSTO3 WHEN
                                           NULL THEN NULL ELSE
                                           (TEKNISA.CUSTO_PRODUTO (@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO3,
                                           (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) END) AS CUSTOPLANCENT3,

                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END)) AS CUSTOREALCENT3,

                                    CP.CDPRODCPLA CDPRODUTO
                                FROM CONSPLAN CP, PARAMGERAL PG,  CARDIAPME CDI,
                                    (SELECT  CDFILIAL, CDSERVFILI, MAX(DTCARDIAPME) AS DTREFECUSTMES
                                       FROM  CARDIAPME
                                       WHERE CDFILIAL       =    @V_CDFILIAL       AND
                                             CDSERVFILI     =    @V_CDSERVFILI AND
                                             DTCARDIAPME BETWEEN @V_DTINI AND @V_DTFIM
                                      GROUP BY CDFILIAL, CDSERVFILI) CD
                                WHERE
                                    CP.CDFILICPLA    =  @V_CDFILIAL        AND
                                    CP.NRCONSPLAN    =  @V_CDSEQUENCIAL    AND
                                    CD.CDFILIAL      =  CP.CDFILICPLA      AND
                                    CD.CDSERVFILI    =  CP.CDSERVCPLA      AND
                                    PG.CDPARGERAL    = '0001'              AND
                                    CDI.CDSERVFILI   =  CP.CDSERVCPLA      AND
                                    CDI.CDFILIAL     =  @V_CDFILIAL        AND
                                    CDI.CDSERVFILI   =  @V_CDSERVFILI      AND
                                    CDI.CDFILCENTPME =  CP.CDFILCENTPME    AND
                                    CDI.DTCARDIAPME   =  CP.DTCONSPLAN     AND
                                    CDI.DTCARDIAPME  BETWEEN @V_DTINI AND @V_DTFIM

                                UNION ALL

                                SELECT
                                    C.CDFILIAL,
                                    C.CDSERVFILI,
                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END)) CUSTOPLAN1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END)) CUSTOPLAN2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END)) CUSTOPLAN3,
                                    (CASE @V_NRTIPOCUSTO1 WHEN
                                             NULL THEN NULL ELSE
                                             (C.QTRETIRADA * (TEKNISA.CUSTO_PRODUTO (C.CDFILIAL, C.CDPRODUTO, @V_NRTIPOCUSTO1, C.DTCARDAPIO, GETDATE()))) END) AS CUSTOREAL1,

                                    (CASE @V_NRTIPOCUSTO2 WHEN
                                             NULL THEN NULL ELSE
                                             (C.QTRETIRADA * (TEKNISA.CUSTO_PRODUTO (C.CDFILIAL, C.CDPRODUTO, @V_NRTIPOCUSTO2, C.DTCARDAPIO, GETDATE()))) END) AS CUSTOREAL2,

                                    (CASE @V_NRTIPOCUSTO3 WHEN
                                             NULL THEN NULL ELSE
                                             (C.QTRETIRADA * (TEKNISA.CUSTO_PRODUTO (C.CDFILIAL, C.CDPRODUTO, @V_NRTIPOCUSTO3, C.DTCARDAPIO, GETDATE()))) END) AS CUSTOREAL3,

                                             /*CLCULO DA CENTRAL*/

                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE 0 END)) CUSTOPLANCENT1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE 0 END)) CUSTOPLANCENT2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE 0 END)) CUSTOPLANCENT3,
                                    (CASE @V_NRTIPOCUSTO1 WHEN
                                             NULL THEN NULL ELSE
                                             (C.QTRETIRADA * (TEKNISA.CUSTO_PRODUTO (@V_CDFILCENTPME, C.CDPRODUTO, @V_NRTIPOCUSTO1, C.DTCARDAPIO, GETDATE())))  END) AS CUSTOREALCENT1,

                                    (CASE @V_NRTIPOCUSTO2 WHEN
                                             NULL THEN NULL ELSE
                                             (C.QTRETIRADA * (TEKNISA.CUSTO_PRODUTO (@V_CDFILCENTPME, C.CDPRODUTO, @V_NRTIPOCUSTO2, C.DTCARDAPIO, GETDATE()))) END) AS CUSTOREALCENT2,

                                    (CASE @V_NRTIPOCUSTO3 WHEN
                                             NULL THEN NULL ELSE
                                             (C.QTRETIRADA * (TEKNISA.CUSTO_PRODUTO (@V_CDFILCENTPME, C.CDPRODUTO, @V_NRTIPOCUSTO3, C.DTCARDAPIO, GETDATE()))) END) AS CUSTOREALCENT3,
                                    C.CDPRODUTO
                                FROM
                                    (
                                    SELECT
                                       CA.CDFILIAL,
                                       CA.CDSERVFILI,
                                       CA.DTCARDAPIO,
                                       SUM(IR.QTRETIRADA * PR.VRFATOCONV) AS QTRETIRADA,
                                       PR.CDPRODUTO
                                    FROM
                                       CARDADIA CA,
                                       PRODUTO  PR,
                                       ITEMRETI IR
                                    WHERE
                                       (IR.CDFILIAL       =     @V_CDFILIAL       )   AND
                                       (CA.CDFILIAL       =     @V_CDFILIAL       )   AND
                                       (CA.CDSERVFILI     =     @V_CDSERVFILI )   AND
                                       (PR.CDPRODUTO      =     PR.CDPRODESTO         )   AND
                                       (PR.CDPRODUTO      =     IR.CDPRODUTO          )   AND
                                       (CA.CDFILIAL       =     IR.CDFILIAL           )   AND
                                       (IR.NRCARDAPIO     =     CA.NRCARDAPIO         )   AND
                                       (CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM)
                                    GROUP BY CA.CDFILIAL, CA.CDSERVFILI,  CA.DTCARDAPIO,  PR.CDPRODUTO) C

                                UNION ALL

                                SELECT
                                    CA.CDFILIAL,
                                    CA.CDSERVFILI,
                                    ((CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE  0 END)) CUSTOPLAN1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE  0 END)) CUSTOPLAN2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE  0 END)) CUSTOPLAN3,
                                    ((CASE @V_NRTIPOCUSTO1 WHEN
                                      NULL THEN NULL ELSE
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREAL1,

                                    ((CASE @V_NRTIPOCUSTO2 WHEN
                                      NULL THEN NULL ELSE
                                      ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREAL2,

                                    ((CASE @V_NRTIPOCUSTO3 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREAL3,

                                            /*CLCULO DA CENTRAL*/

                                    (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLANCENT1,
                                    (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLANCENT2,
                                    (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLANCENT3,
                                    ((CASE @V_NRTIPOCUSTO1 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) END)) AS CUSTOREALCENT1,
                                    ((CASE @V_NRTIPOCUSTO2 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) END)) AS CUSTOREALCENT2,
                                    ((CASE @V_NRTIPOCUSTO3 WHEN
                                            NULL THEN NULL ELSE
                                            ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) END)) AS CUSTOREALCENT3,
                                    CNE.CDPRODUTO
                                FROM
                                    (
                                    SELECT
                                        DTMESCARD,
                                        CDSERVFILI,
                                        SUM(QTCOMEFETCAR) AS TOTCOMEN
                                     FROM
                                        CARDADIA CDR
                                     WHERE
                                        (CDR.CDFILIAL      = @V_CDFILIAL  )     AND
                                        (CDR.CDSERVFILI    = @V_CDSERVFILI)     AND
                                        (DTCARDAPIO BETWEEN  @V_DTINI AND @V_DTFIM  )
                                     GROUP BY
                                        DTMESCARD, CDSERVFILI) TC,
                                    CARDADIA  CA,
                                    RATENESTO RNE,
                                    CUSTNESTO CNE
                                WHERE
                                    (CA.DTCARDAPIO BETWEEN  @V_DTINI AND @V_DTFIM  )  AND
                                    (CA.CDFILIAL         =  @V_CDFILIAL        )  AND
                                    (RNE.CDFILIAL        =  @V_CDFILIAL        )  AND
                                    (CNE.CDFILIAL        =  @V_CDFILIAL        )  AND
                                    (RNE.CDSERVFILI      =  @V_CDSERVFILI  )  AND
                                    (CA.CDSERVFILI       =  @V_CDSERVFILI  )  AND
                                    (CA.CDSERVFILI       =  RNE.CDSERVFILI         )  AND
                                    (RNE.CDPRODUTO       =  CNE.CDPRODUTO          )  AND
                                    (TC.DTMESCARD        =  CA.DTMESCARD           )  AND
                                    (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0  )  AND
                                    (NOT CNE.VRREALNESTO IS NULL                   )  AND
                                    (CONVERT (VARCHAR, MONTH (CA.DTCARDAPIO)))+(CONVERT (VARCHAR, YEAR  (CA.DTCARDAPIO))) = (CONVERT (VARCHAR, MONTH (CNE.DTCUSTNESTO)))+(CONVERT (VARCHAR, YEAR  (CNE.DTCUSTNESTO)))

                                UNION ALL

                                SELECT
                                    RNE.CDFILIAL,
                                    RNE.CDSERVFILI,
                                    (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLAN1,
                                    (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLAN2,
                                    (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLAN3,
                                    ((CASE @V_NRTIPOCUSTO1 WHEN
                                       NULL THEN NULL ELSE
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREAL1,

                                    ((CASE @V_NRTIPOCUSTO2 WHEN
                                       NULL THEN NULL ELSE
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREAL2,

                                    ((CASE @V_NRTIPOCUSTO3 WHEN
                                             NULL THEN NULL ELSE
                                             ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREAL3,

                                             /*CLCULO DA CENTRAL*/

                                    (CASE @V_NRTIPOCUSTO1 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLANCENT1,
                                    (CASE @V_NRTIPOCUSTO2 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLANCENT2,
                                    (CASE @V_NRTIPOCUSTO3 WHEN NULL THEN NULL ELSE  0 END) CUSTOPLANCENT3,
                                    ((CASE @V_NRTIPOCUSTO1 WHEN
                                             NULL THEN NULL ELSE
                                             ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREALCENT1,

                                    ((CASE @V_NRTIPOCUSTO2 WHEN
                                       NULL THEN NULL ELSE
                                       ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREALCENT2,

                                    ((CASE @V_NRTIPOCUSTO3 WHEN
                                             NULL THEN NULL ELSE
                                             ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5)END)) AS CUSTOREALCENT3,
                                    TCN.CDPRODUTO
                                FROM
                                     DATA        DT, RATENESTO   RNE,  CARDADIA    CA,
                                    (
                                    SELECT
                                        DTMESCARD,         CDSERVFILI,
                                        SUM(QTCOMEFETCAR) AS TOTCOMEN
                                     FROM
                                        CARDADIA CDR
                                     WHERE
                                        (CDR.CDFILIAL     = @V_CDFILIAL       ) AND
                                        (CDR.CDSERVFILI   = @V_CDSERVFILI ) AND
                                        (DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM )
                                     GROUP BY DTMESCARD, CDSERVFILI) TC,
                                     (
                                     SELECT
                                         (CONVERT (VARCHAR, MONTH (NF.DTENTRSAID)))+(CONVERT (VARCHAR, YEAR (NF.DTENTRSAID))) AS DTMESNF,
                                         IP.CDPRODUTO,
                                         SUM(IP.VRTOTAITEM) AS VRTOTAITEM
                                      FROM
                                         NOTAFISCAL  NF,
                                         ITEMPRODUTO IP
                                      WHERE
                                        (NF.IDENTRSAIDOP     =     'E'                   )  AND
                                        (IP.CDFILIAL         =     NF.CDFILIAL           )  AND
                                        (IP.NRLANCTONF       =     NF.NRLANCTONF         )  AND
                                        (NF.CDFILIAL         =     @V_CDFILIAL       )  AND
                                        (IP.CDFILIAL         =     @V_CDFILIAL       )  AND
                                        (NF.DTENTRSAID BETWEEN @V_DTINI AND @V_DTFIM     )
                                      GROUP BY
                                         (CONVERT (VARCHAR, MONTH (NF.DTENTRSAID)))+(CONVERT (VARCHAR, YEAR (NF.DTENTRSAID))),
                                         IP.CDPRODUTO                              ) TCN
                                WHERE
                                    (CA.CDFILIAL         =      @V_CDFILIAL       ) AND
                                    (RNE.CDFILIAL        =      @V_CDFILIAL       ) AND
                                    (CA.CDFILIAL         =      RNE.CDFILIAL          ) AND
                                    (CA.CDSERVFILI       =      @V_CDSERVFILI ) AND
                                    (RNE.CDSERVFILI      =      @V_CDSERVFILI ) AND
                                    (TCN.CDPRODUTO       =      RNE.CDPRODUTO         ) AND
                                    (TC.DTMESCARD        =      CA.DTMESCARD          ) AND
                                    (TC.CDSERVFILI       =      CA.CDSERVFILI         ) AND
                                    (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0     ) AND
                                    (CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM      ) AND
                                     (DT.DTDATA BETWEEN @V_DTINI AND @V_DTFIM)    AND
                                    ((CONVERT (VARCHAR, MONTH (DT.DTDATA)))+(CONVERT (VARCHAR, YEAR (DT.DTDATA)))= TCN.DTMESNF)   AND
                                    (NOT EXISTS (
                                                 SELECT
                                                        CDFILIAL
                                                 FROM
                                                        CUSTNESTO
                                                 WHERE
                                                        CDFILIAL         =     @V_CDFILIAL  AND
                                                        DTCUSTNESTO      =     CA.DTCARDAPIO    AND
                                                        CDPRODUTO        =     RNE.CDPRODUTO    AND
                                                        NOT VRREALNESTO IS NULL
                                                 ))) PR
                               WHERE
                                    (SVC.CDFILIAL       =  @V_CDFILIAL  )  AND
                                    (SVC.CDSERVFILI     =  @V_CDSERVFILI)  AND
                                    (SVC.CDGRUPSERV     =  @V_CDGRUPSERV)  AND
                                    (SVC.CDFILIAL       =  PR.CDFILIAL  )  AND
                                    (SVC.CDSERVFILI     =  PR.CDSERVFILI)
                               GROUP BY PR.CDPRODUTO

                           OPEN C_PRODUTO;
                           FETCH NEXT FROM C_PRODUTO INTO
                                       @V_CUSTOPLAN1, @V_CUSTOPLAN2, @V_CUSTOPLAN3, @V_CUSTOREAL1, @V_CUSTOREAL2, @V_CUSTOREAL3,
                                       @V_CUSTOPLANCENT1, @V_CUSTOPLANCENT2, @V_CUSTOPLANCENT3, @V_CUSTOREALCENT1, @V_CUSTOREALCENT2,
                                       @V_CUSTOREALCENT3, @V_CDPRODUTO;

                           WHILE (@@FETCH_STATUS = 0) BEGIN

                              INSERT INTO ETL_RESUFOOD
                              (
                              CDFILIAL,              CDAREAGERE,             CDSUPERVISOR,
                              CDGOPERAC,             CDEMPRESA,              CDSEGMER,
                              CDPRODUTO,             CDANOBI,                CDMESBI,
                              BIETLFOOD,             TRETLFOOD,              SEETLFOOD,
                              VRCUSPLAETLFOO1,       VRCUSPLAETLFOO2,        VRCUSPLAETLFOO3,
                              VRCUSREAETLFOO1,       VRCUSREAETLFOO2,        VRCUSREAETLFOO3,
                              CDGRUPSERV,            CDFILISERVFILI,         VRCUSPLACENTFO1,
                              VRCUSPLACENTFO2,       VRCUSPLACENTFO3,        VRCUSREACENTFO1,
                              VRCUSREACENTFO2,       VRCUSREACENTFO3,        CDETLFILCENTPME
                              )
                           VALUES
                              (
                              @V_CDFILIAL,    @V_CDAREAGERE,  @V_CDSUPERVISOR,
                              @V_CDGOPERAC,   @V_CDEMPRESA,   @V_CDSEGMER,
                              @V_CDPRODUTO,   @V_ANO,         @V_MES,
                              @V_BIM,          @V_TRI,          @V_SEM,
                              @V_CUSTOPLAN1,  @V_CUSTOPLAN2,   @V_CUSTOPLAN3,
                              @V_CUSTOREAL1,  @V_CUSTOREAL2,   @V_CUSTOREAL3,
                              @V_CDGRUPSERV,  @V_CDFILIAL+@V_CDSERVFILI,
                              @V_CUSTOPLANCENT1, @V_CUSTOPLANCENT2,  @V_CUSTOPLANCENT3,
                              @V_CUSTOREALCENT1, @V_CUSTOREALCENT2,  @V_CUSTOREALCENT3,
                              @V_CDFILCENTPME);

                             SET @V_COUNTER = @V_COUNTER+1;
                             IF @V_COUNTER >= 500 BEGIN
                                 COMMIT TRANSACTION;
                                 SET @V_COUNTER= 0;
                                 BEGIN TRANSACTION;
                              END;
                              FETCH NEXT FROM C_PRODUTO INTO
                                          @V_CUSTOPLAN1, @V_CUSTOPLAN2, @V_CUSTOPLAN3, @V_CUSTOREAL1, @V_CUSTOREAL2, @V_CUSTOREAL3,
                                          @V_CUSTOPLANCENT1, @V_CUSTOPLANCENT2, @V_CUSTOPLANCENT3, @V_CUSTOREALCENT1, @V_CUSTOREALCENT2,
                                          @V_CUSTOREALCENT3, @V_CDPRODUTO;

                        END;
                        CLOSE C_PRODUTO;
                        DEALLOCATE C_PRODUTO;


                        INSERT INTO ETL_RESUSERV
                          (CDFILIAL,     CDAREAGERE, CDSUPERVISOR, CDGOPERAC, CDEMPRESA,    CDSEGMER,
                           CDGRUPSERV,   CDFILISERVFILI, CDANOBI,  CDMESBI, BIETLSERV,    TRETLSERV,
                           SEETLSERV,    QTCOMESTETLSERV, QTCOMEFEETLSERV, VRCUSPADETLSERV )
                        VALUES
                           (@V_CDFILIAL,     @V_CDAREAGERE, @V_CDSUPERVISOR, @V_CDGOPERAC, @V_CDEMPRESA, @V_CDSEGMER,
                            @V_CDGRUPSERV,   @V_CDFILIAL+@V_CDSERVFILI, @V_ANO, @V_MES, @V_BIM,  @V_TRI,
                            @V_SEM, @V_QTCOMESTICAR, @V_QTCOMEFETCAR,    @V_VRCUSTPADR);

                        SET @V_COUNTER = @V_COUNTER+1;

                     IF @V_COUNTER >= 500 BEGIN
                        COMMIT TRANSACTION;
                        SET @V_COUNTER = 0;
                        BEGIN TRANSACTION;
                     END;
                    FETCH NEXT FROM C_SERVICO INTO @V_CDSERVFILI, @V_CDGRUPSERV, @V_QTCOMESTICAR, @V_QTCOMEFETCAR;
               END;
               CLOSE C_SERVICO;
               DEALLOCATE C_SERVICO;

               DELETE FROM CONSPLAN
               WHERE NRCONSPLAN = @V_CDSEQUENCIAL;
            END;
         END;
         FETCH NEXT FROM C_ETL INTO
                             @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                             @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                             @V_CDSEGMER, @V_CDFILCENTPME;

      END;

      CLOSE C_ETL;
      DEALLOCATE C_ETL;

      COMMIT TRANSACTION;
      SET @V_DTINI = DATEADD(MM, 1, @V_DTINI);
      BEGIN TRANSACTION;
   END
   ELSE BEGIN
      DECLARE C_NRTPCUS CURSOR FOR
         SELECT CDTIPOCUSTO, CONVERT(FLOAT,CDTIPOCUSTO) NRTIPOCUSTO
         FROM   TIPOCUSTO
         WHERE IDTPCUSTOGSC = 'S'
         ORDER BY NRTIPOCUSTO

      OPEN C_NRTPCUS;
      FETCH NEXT FROM C_NRTPCUS INTO @V_CDTIPOCUSTO,@V_NRTIPOCUSTO;


      WHILE (@@FETCH_STATUS = 0) BEGIN
         WHILE (@V_DTINI  <=  @P_DTFINA)    BEGIN
            BEGIN TRANSACTION;
            SET @V_DTFIM =  DATEADD(MM, 1,@V_DTINI);
            SET @V_DTFIM =  DATEADD(DD,-1,@V_DTFIM);

            SET @V_MES  =  (CONVERT (VARCHAR, MONTH (@V_DTFIM)));
            SET @V_ANO  =  (CONVERT (VARCHAR, YEAR  (@V_DTFIM)));

            SET @V_BIM        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 2) + 1);
            SET @V_TRI        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 3) + 1);
            SET @V_SEM        =   CONVERT (VARCHAR,FLOOR((@V_MES - 1) / 6) + 1);



            DECLARE C_ETL CURSOR FOR
               SELECT FL.CDFILIAL,        FL.CDAREAGERE,          FL.DTINICIALBI,
                       FL.CDSUPERVISOR,    FL.CDGOPERAC,           FL.CDEMPRESA,
                       FL.CDSEGMER , FL.CDFILCENTPME
                  FROM FILIAL FL, PARAMFILIAL P
                 WHERE P.CDFILIAL = FL.CDFILIAL
                   AND FL.IDFUNCAOFILI IS NULL
                   AND FL.DTINICIALBI  IS NOT NULL
                  and ISNULL(IDCTRLESTQ, @w_S) <> @w_N
                  AND ISNULL(IDCNTRRESC, @w_N) <> @w_S
                  ORDER BY FL.CDFILIAL

            OPEN C_ETL;
            FETCH NEXT FROM C_ETL INTO
                                @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                                @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                                @V_CDSEGMER, @V_CDFILCENTPME;

            WHILE (@@FETCH_STATUS = 0) BEGIN

               IF (CONVERT (DATETIME, ('01' + '/' + CONVERT(VARCHAR, MONTH(@V_DTINICIALBI))+'/'+ CONVERT (VARCHAR, YEAR(@V_DTINICIALBI)))) <= @V_DTINI) BEGIN
                  SET @V_STR1 = 'CONSPLAN'+@V_CDFILIAL;
                  EXEC TEKNISA.NOVO_CODIGO @V_STR1, @V_CDSEQUENCIAL,1;
                  SET @V_CDSEQUENCIAL = SUBSTRING(@V_CDSEQUENCIAL,11,10);

                  SET @V_STR1 = ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTINI), 112) + '_');
                  SET @V_STR1 = ('_' + CONVERT(VARCHAR(8), CONVERT(DATETIME, @V_DTFIM), 112) + '_');

                  EXEC TEKNISA.CONSUMO_PLANEJADO_PLA
                                           @V_CDFILIAL,
                                           'T',
                                           @V_DTINI,
                                           @V_DTFIM,
                                           'T',
                                           'CFP',
                                           'N',
                                            0,
                                           'N',
                                           @V_CDSEQUENCIAL,
                                           '0',
                                           'zzzzzzzzzz',
                                           '',
                                           @V_STR1,
                                           @V_STR1;

                  DECLARE C_SERVICO CURSOR FOR
                           SELECT
                            SE.CDSERVFILI,                 SE.CDGRUPSERV,
                            SUM(SE.QTCOMESTICAR / TOTAL) AS QTCOMESTICAR,
                            SUM(SE.QTCOMEFETCAR / TOTAL) AS QTCOMEFETCAR
                       FROM (SELECT
                                  CP.DTCONSPLAN DTCARDAPIO,
                                  SRV.CDSERVFILI, GS.CDGRUPSERV,
                                  SUM(CAR.QTCOMESTICAR) QTCOMESTICAR,
                                  SUM(CAR.QTCOMEFETCAR) QTCOMEFETCAR,
                                  COUNT(*) AS TOTAL
                             FROM  CARDADIA CAR, CONSPLAN CP, SERVICO SRV LEFT JOIN GRUPSERV GS ON
                                                               GS.CDGRUPSERV =   SRV.CDGRUPSERV
                             WHERE  CAR.CDFILIAL       =   SRV.CDFILIAL
                              AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   @V_CDFILIAL
                              AND CAR.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                              AND CP.CDFILICPLA      =   @V_CDFILIAL
                              AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                              AND CP.DTCONSPLAN      =   CAR.DTCARDAPIO
                              AND CP.NRCONSPLAN      =   @V_CDSEQUENCIAL
                            GROUP BY CP.DTCONSPLAN, SRV.CDSERVFILI,  SRV.CDFILIAL,  GS.CDGRUPSERV

                            UNION ALL

                             SELECT
                                  CAR.DTCARDAPIO,
                                  SRV.CDSERVFILI, GS.CDGRUPSERV,
                                  ISNULL(SUM(CAR.QTCOMESTICAR), 0) QTCOMESTICAR,
                                  ISNULL(SUM(CAR.QTCOMEFETCAR), 0) QTCOMEFETCAR,
                                  COUNT(*) AS TOTAL
                             FROM CARDADIA CAR, SERVICO SRV LEFT JOIN GRUPSERV GS ON
                                                        GS.CDGRUPSERV  =   SRV.CDGRUPSERV
                             WHERE CAR.CDFILIAL       =   SRV.CDFILIAL
                              AND CAR.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   @V_CDFILIAL
                              AND CAR.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                              AND CAR.QTCOMESTICAR = 0
                              AND CAR.CDSERVFILI  NOT IN (SELECT CDSERVCPLA
                                                           FROM CONSPLAN CP
                                                         WHERE  CP.DTCONSPLAN BETWEEN @V_DTINI AND @V_DTFIM
                                                           AND  CP.DTCONSPLAN = CAR.DTCARDAPIO
                                                           AND  CP.NRCONSPLAN = @V_CDSEQUENCIAL
                                                           AND  CP.CDFILICPLA = @V_CDFILIAL)
                            GROUP BY CAR.DTCARDAPIO,SRV.CDSERVFILI, SRV.CDFILIAL, GS.CDGRUPSERV

                            UNION ALL
                                            /*QUANTIDADE PLANEJADA MERENDA*/
                            SELECT
                                   CD.DTCARDAPIO,
                                   SRV.CDSERVFILI, GS.CDGRUPSERV,
                                   SUM(CD.QTCOMESTICAR) QTCOMESTICAR,
                                   SUM(QTCLIESTICAR) QTCOMEFETCAR,
                                   COUNT(*) AS TOTAL
                              FROM  CONSPLAN CP,
                                   (SELECT  CDFILCENTPME, CDFILIAL, CDSERVFILI, DTCARDIAPME DTCARDAPIO, NRCARDPME,
                                      SUM(QTCOMESTCPME) QTCOMESTICAR, SUM(QTCLIESTCPME) QTCLIESTICAR
                                    FROM CARDIAPME
                                    WHERE
                                       CDFILCENTPME = @V_CDFILIAL  AND
                                       CDFILIAL = @V_CDFILIAL  AND
                                      (DTCARDIAPME BETWEEN @V_DTINI AND @V_DTFIM)
                                    GROUP BY CDFILCENTPME, CDFILIAL, CDSERVFILI, DTCARDIAPME, NRCARDPME) CD,
                                    SERVICO SRV LEFT JOIN GRUPSERV GS ON
                                       GS.CDGRUPSERV =   SRV.CDGRUPSERV
                              WHERE CD.CDFILIAL       =   SRV.CDFILIAL
                              AND CD.CDSERVFILI     =   SRV.CDSERVFILI
                              AND SRV.CDFILIAL       =   @V_CDFILIAL
                              AND CD.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM
                              AND CP.CDFILICPLA      =   @V_CDFILIAL
                              AND CP.CDSERVCPLA      =   SRV.CDSERVFILI
                              AND CP.DTCONSPLAN      =   CD.DTCARDAPIO
                              AND CP.NRCONSPLAN      =   @V_CDSEQUENCIAL
                              GROUP BY CD.DTCARDAPIO, SRV.CDSERVFILI, SRV.CDFILIAL, GS.CDGRUPSERV)SE
                       GROUP BY SE.CDSERVFILI, SE.CDGRUPSERV

                  OPEN C_SERVICO;
                  FETCH NEXT FROM C_SERVICO INTO @V_CDSERVFILI, @V_CDGRUPSERV, @V_QTCOMESTICAR, @V_QTCOMEFETCAR;

                  WHILE (@@FETCH_STATUS = 0) BEGIN

                     SELECT @V_VRCUSTPADR = MAX(VRCUSTPADR)
                     FROM CUSTPADR
                     WHERE CDFILIAL     = @V_CDFILIAL
                       AND CDSERVFILI   = @V_CDSERVFILI
                       AND DTREFCUSPADR = (SELECT MAX(DTREFCUSPADR)
                                             FROM   CUSTPADR
                                             WHERE  CDFILIAL      = @V_CDFILIAL
                                               AND  CDSERVFILI    = @V_CDSERVFILI
                                               AND  DTREFCUSPADR <= @V_DTFIM);

                     DECLARE C_PRODUTO CURSOR FOR
                        SELECT
                            SUM(CUSTOREAL) AS CUSTOREAL,
                            SUM(CUSTOPLAN) AS CUSTOPLAN,
                            SUM(CUSTOREALCENT) AS CUSTOREALCENT,
                            SUM(CUSTOPLANCENT) AS CUSTOPLANCENT,
                            PR.CDPRODUTO
                        FROM GRUPSERV GPS, SERVICO SVC,
                            (SELECT
                                 CP.CDFILICPLA CDFILIAL,
                                 CP.CDSERVCPLA CDSERVFILI,
                                 (TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO, (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) AS CUSTOPLAN,
                                 0 AS CUSTOREAL,
                                 (TEKNISA.CUSTO_PRODUTO(@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO, (CASE PG.IDUTCARDPADR WHEN 'S' THEN  CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) AS CUSTOPLANCENT,
                                 0 AS CUSTOREALCENT,
                                 CP.CDPRODCPLA CDPRODUTO
                             FROM
                                 CONSPLAN CP, PARAMGERAL PG,
                                 (SELECT  CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD, MAX(CM.DTREFECUSTMES) DTREFECUSTMES
                                  FROM    CARDADIA CD, CARDAMES CM
                                  WHERE   CD.CDFILIAL       =    @V_CDFILIAL       AND
                                          CD.CDSERVFILI     =    @V_CDSERVFILI AND
                                          CD.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM   AND
                                          (CD.CDFILIAL   = CM.CDFILIAL     ) AND
                                          (CD.CDSERVFILI = CM.CDSERVFILI   ) AND
                                          (CD.DTMESCARD  = CM.DTMESCARDAPIO)
                                  GROUP BY CD.CDFILIAL, CD.CDSERVFILI, CD.DTMESCARD) CD
                             WHERE
                                 CP.CDFILICPLA   =  @V_CDFILIAL              AND
                                 CP.NRCONSPLAN   =  @V_CDSEQUENCIAL              AND
                                 CD.CDFILIAL     =  CP.CDFILICPLA               AND
                                 CD.CDSERVFILI   =  CP.CDSERVCPLA               AND
                                 PG.CDPARGERAL   = '0001'                       AND
                                 CD.DTMESCARD    = CONVERT (DATETIME, ('01' + '/' + CONVERT(VARCHAR, MONTH(CP.DTCONSPLAN))+'/'+ CONVERT (VARCHAR,YEAR(CP.DTCONSPLAN))))

                             UNION ALL

                            SELECT
                                 H.CDFILIAL, H.CDSERVFILI,
                                 ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5) AS CUSTOPLAN,
                                 0 AS CUSTOREAL,
                                                           /*CLCULO DA CENTRAL*/
                                 ROUND(CNE.VRPLANNESTO * (RNE.PERATENESTO/100) * (CD.QTCOMESTICAR/H.TOTCOMEN), 5) AS CUSTOPLANCENT,
                                 0 AS CUSTOREALCENT,
                                 CNE.CDPRODUTO AS CDPRODUTO
                             FROM
                                 (SELECT CDR.CDFILIAL,   CDR.CDSERVFILI,  CDR.DTMESCARD,
                                     SUM(QTCOMESTICAR) AS TOTCOMEN
                                  FROM CARDADIA CDR
                                  WHERE
                                     (CDR.CDFILIAL         =   @V_CDFILIAL       ) AND
                                     (CDR.CDSERVFILI       =   @V_CDSERVFILI ) AND
                                     (CDR.DTCARDAPIO BETWEEN   @V_DTINI AND @V_DTFIM )
                                  GROUP BY CDSERVFILI, CDR.CDFILIAL, CDR.CDSERVFILI, CDR.DTMESCARD
                                 ) H, RATENESTO RNE, CUSTNESTO CNE, CARDADIA  CD
                             WHERE
                                 (CD.CDFILIAL      =    @V_CDFILIAL         )   AND
                                 (H.CDFILIAL       =    @V_CDFILIAL         )   AND
                                 (CNE.CDFILIAL     =    @V_CDFILIAL         )   AND
                                 (RNE.CDFILIAL     =    @V_CDFILIAL         )   AND
                                 (CD.CDSERVFILI    =    @V_CDSERVFILI   )   AND
                                 (H.CDSERVFILI     =    @V_CDSERVFILI   )   AND
                                 (RNE.CDSERVFILI   =    @V_CDSERVFILI   )   AND
                                 (CNE.CDPRODUTO    =    RNE.CDPRODUTO           )   AND
                                 (CD.DTMESCARD     =    H.DTMESCARD             )   AND
                                 (CD.DTCARDAPIO BETWEEN   @V_DTINI AND @V_DTFIM )   AND
                                 (NOT H.TOTCOMEN IS NULL AND H.TOTCOMEN <> 0 )

                             UNION ALL
      ------------------------------------------------/* CUSTO PLANEJADO MERENDA */
                              SELECT
                                 CP.CDFILICPLA CDFILIAL,
                                 CP.CDSERVCPLA CDSERVFILI,
                                 (TEKNISA.CUSTO_PRODUTO(CP.CDFILICPLA, CP.CDPRODCPLA, @V_NRTIPOCUSTO1, (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) AS CUSTOPLAN,
                                 0 AS CUSTOREAL,
                                    /*CLCULO DA CENTRAL*/
                                 (TEKNISA.CUSTO_PRODUTO(@V_CDFILCENTPME, CP.CDPRODCPLA, @V_NRTIPOCUSTO1, (CASE PG.IDUTCARDPADR WHEN 'S' THEN CD.DTREFECUSTMES ELSE CP.DTCONSPLAN END), GETDATE()) * CP.QTCONSPLAN) AS CUSTOPLANCENT,
                                 0 AS CUSTOREALCENT,
                                 CP.CDPRODCPLA CDPRODUTO
                             FROM CONSPLAN CP, PARAMGERAL PG,  CARDIAPME CDI,
                                 (SELECT  CDFILIAL, CDSERVFILI, MAX(DTCARDIAPME) AS DTREFECUSTMES
                                    FROM    CARDIAPME
                                    WHERE   CDFILIAL       =    @V_CDFILIAL       AND
                                           CDSERVFILI     =    @V_CDSERVFILI AND
                                          DTCARDIAPME BETWEEN @V_DTINI AND @V_DTFIM
                                   GROUP BY CDFILIAL, CDSERVFILI ) CD
                             WHERE
                                 CP.CDFILICPLA    =  @V_CDFILIAL              AND
                                 CP.NRCONSPLAN    =  @V_CDSEQUENCIAL              AND
                                 CD.CDFILIAL      =  CP.CDFILICPLA               AND
                                 CD.CDSERVFILI    =  CP.CDSERVCPLA               AND
                                 PG.CDPARGERAL    = '0001'                       AND
                                 CDI.CDSERVFILI   =  CP.CDSERVCPLA               AND
                                 CDI.CDFILIAL     =  @V_CDFILIAL              AND
                                 CDI.CDSERVFILI   =  @V_CDSERVFILI        AND
                                 CDI.CDFILCENTPME =  CP.CDFILCENTPME             AND
                                 CDI.DTCARDIAPME   =  CP.DTCONSPLAN               AND
                                 CDI.DTCARDIAPME  BETWEEN @V_DTINI AND @V_DTFIM

                             UNION ALL

                             SELECT
                                 C.CDFILIAL,
                                 C.CDSERVFILI,
                                 0 AS CUSTOPLAN,
                                 (C.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(C.CDFILIAL, C.CDPRODUTO, @V_NRTIPOCUSTO, C.DTCARDAPIO, GETDATE())) AS CUSTOREAL,
                                          /*CLCULO DA CENTRAL*/
                                 0 AS CUSTOPLANCENT,
                                 (C.QTRETIRADA * TEKNISA.CUSTO_PRODUTO(@V_CDFILCENTPME, C.CDPRODUTO, @V_NRTIPOCUSTO, C.DTCARDAPIO, GETDATE())) AS CUSTOREALCENT,
                                 C.CDPRODUTO
                             FROM
                                 (SELECT
                                    CA.CDFILIAL,
                                    CA.CDSERVFILI,
                                    CA.DTCARDAPIO,
                                    SUM(IR.QTRETIRADA * PR.VRFATOCONV) AS QTRETIRADA,
                                    PR.CDPRODUTO
                                 FROM
                                    CARDADIA CA,
                                    PRODUTO  PR,
                                    ITEMRETI IR
                                 WHERE
                                    (IR.CDFILIAL       =     @V_CDFILIAL       )   AND
                                    (CA.CDFILIAL       =     @V_CDFILIAL       )   AND
                                    (CA.CDSERVFILI     =     @V_CDSERVFILI )   AND
                                    (PR.CDPRODUTO      =     PR.CDPRODESTO         )   AND
                                    (PR.CDPRODUTO      =     IR.CDPRODUTO          )   AND
                                    (CA.CDFILIAL       =     IR.CDFILIAL           )   AND
                                    (IR.NRCARDAPIO     =     CA.NRCARDAPIO         )   AND
                                    (CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM   )
                                 GROUP BY CA.CDFILIAL, CA.CDSERVFILI, CA.DTCARDAPIO, PR.CDPRODUTO) C

                             UNION ALL

                             SELECT
                                 CA.CDFILIAL, CA.CDSERVFILI,
                                 0 AS CUSTOPLAN,
                                 ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREAL,                      /*CLCULO DA CENTRAL*/

                                 0 AS CUSTOPLANCENT,
                                 ROUND(CNE.VRREALNESTO * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREALCENT,
                                 CNE.CDPRODUTO
                             FROM
                                 (SELECT DTMESCARD, CDSERVFILI,
                                     SUM(QTCOMEFETCAR) AS TOTCOMEN
                                  FROM CARDADIA CDR
                                  WHERE
                                     (CDR.CDFILIAL      = @V_CDFILIAL        )     AND
                                     (CDR.CDSERVFILI    = @V_CDSERVFILI  )     AND
                                     (DTCARDAPIO BETWEEN  @V_DTINI AND @V_DTFIM  )
                                  GROUP BY
                                     DTMESCARD,
                                     CDSERVFILI
                                  ) TC,
                                 CARDADIA  CA,
                                 RATENESTO RNE,
                                 CUSTNESTO CNE
                             WHERE
                                 (CA.DTCARDAPIO BETWEEN  @V_DTINI AND @V_DTFIM  )  AND
                                 (CA.CDFILIAL         =  @V_CDFILIAL        )  AND
                                 (RNE.CDFILIAL        =  @V_CDFILIAL        )  AND
                                 (CNE.CDFILIAL        =  @V_CDFILIAL        )  AND
                                 (RNE.CDSERVFILI      =  @V_CDSERVFILI  )  AND
                                 (CA.CDSERVFILI       =  @V_CDSERVFILI  )  AND
                                 (CA.CDSERVFILI       =  RNE.CDSERVFILI         )  AND
                                 (RNE.CDPRODUTO       =  CNE.CDPRODUTO          )  AND
                                 (TC.DTMESCARD        =  CA.DTMESCARD           )  AND
                                 (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0  )  AND
                                 (NOT CNE.VRREALNESTO IS NULL                   )  AND
                                 (CONVERT (VARCHAR, MONTH (CA.DTCARDAPIO)))+(CONVERT (VARCHAR, YEAR  (CA.DTCARDAPIO))) = (CONVERT (VARCHAR, MONTH (CNE.DTCUSTNESTO)))+(CONVERT (VARCHAR, YEAR  (CNE.DTCUSTNESTO)))

                             UNION ALL

                             SELECT
                                 RNE.CDFILIAL,
                                 RNE.CDSERVFILI,
                                 0 AS CUSTOPLAN,
                                 ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREAL,
                                          /*CLCULO DA CENTRAL*/
                                 0 AS CUSTOPLANCENT,
                                 ROUND(TCN.VRTOTAITEM * (RNE.PERATENESTO/100) * (CA.QTCOMEFETCAR/TC.TOTCOMEN), 5) AS CUSTOREALCENT,
                                 TCN.CDPRODUTO
                             FROM RATENESTO   RNE, CARDADIA    CA, DATA DT,
                                 (SELECT
                                     DTMESCARD,         CDSERVFILI,
                                     SUM(QTCOMEFETCAR) AS TOTCOMEN
                                  FROM CARDADIA CDR
                                  WHERE
                                     (CDR.CDFILIAL     = @V_CDFILIAL       ) AND
                                     (CDR.CDSERVFILI   = @V_CDSERVFILI ) AND
                                     (DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM )
                                  GROUP BY DTMESCARD, CDSERVFILI ) TC,
                                  (
                                  SELECT
                                      (CONVERT (VARCHAR, MONTH (NF.DTENTRSAID)))+(CONVERT (VARCHAR, YEAR (NF.DTENTRSAID))) AS DTMESNF,
                                      IP.CDPRODUTO,
                                      SUM(IP.VRTOTAITEM) AS VRTOTAITEM
                                   FROM NOTAFISCAL  NF, ITEMPRODUTO IP
                                   WHERE
                                     (NF.IDENTRSAIDOP     =     'E'                   )  AND
                                     (IP.CDFILIAL         =     NF.CDFILIAL           )  AND
                                     (IP.NRLANCTONF       =     NF.NRLANCTONF         )  AND
                                     (NF.CDFILIAL         =     @V_CDFILIAL       )  AND
                                     (IP.CDFILIAL         =     @V_CDFILIAL       )  AND
                                     (NF.DTENTRSAID BETWEEN @V_DTINI AND @V_DTFIM     )
                                   GROUP BY
                                      (CONVERT (VARCHAR, MONTH (NF.DTENTRSAID)))+(CONVERT (VARCHAR, YEAR (NF.DTENTRSAID))),
                                      IP.CDPRODUTO) TCN
                             WHERE
                                 (CA.CDFILIAL         =      @V_CDFILIAL       ) AND
                                 (RNE.CDFILIAL        =      @V_CDFILIAL       ) AND
                                 (CA.CDFILIAL         =      RNE.CDFILIAL          ) AND
                                 (CA.CDSERVFILI       =      @V_CDSERVFILI ) AND
                                 (RNE.CDSERVFILI      =      @V_CDSERVFILI ) AND
                                 (TCN.CDPRODUTO       =      RNE.CDPRODUTO         ) AND
                                 (TC.DTMESCARD        =      CA.DTMESCARD          ) AND
                                 (TC.CDSERVFILI       =      CA.CDSERVFILI         ) AND
                                 (NOT TC.TOTCOMEN IS NULL AND TC.TOTCOMEN <> 0     ) AND
                                 (CA.DTCARDAPIO BETWEEN @V_DTINI AND @V_DTFIM      ) AND
                                 (DT.DTDATA BETWEEN @V_DTINI AND @V_DTFIM)    AND
                                 ((CONVERT (VARCHAR, MONTH (DT.DTDATA)))+(CONVERT (VARCHAR, YEAR (DT.DTDATA))) = TCN.DTMESNF   ) AND
                                 (NOT EXISTS (SELECT CDFILIAL
                                              FROM  CUSTNESTO
                                              WHERE
                                                     CDFILIAL         =     @V_CDFILIAL  AND
                                                     DTCUSTNESTO      =     CA.DTCARDAPIO    AND
                                                     CDPRODUTO        =     RNE.CDPRODUTO    AND
                                                     NOT VRREALNESTO IS NULL))) PR
                            WHERE
                                 (SVC.CDFILIAL       =       @V_CDFILIAL      )  AND
                                 (SVC.CDSERVFILI     =       @V_CDSERVFILI)  AND
                                 (SVC.CDFILIAL       =      PR.CDFILIAL          )  AND
                                 (SVC.CDSERVFILI     =      PR.CDSERVFILI        )
                        GROUP BY PR.CDPRODUTO

                        OPEN C_PRODUTO;
                        FETCH NEXT FROM C_PRODUTO INTO 
                                       @V_CUSTOREAL, @V_CUSTOPLAN, @V_CUSTOREALCENT, @V_CUSTOPLANCENT, @V_CDPRODUTO;
                        WHILE (@@FETCH_STATUS = 0) BEGIN

                           INSERT INTO ETL_RESUFOOD
                              ( CDFILIAL,              CDAREAGERE,             CDSUPERVISOR,
                              CDGOPERAC,             CDEMPRESA,              CDSEGMER,
                              CDPRODUTO,             CDANOBI,                CDMESBI,
                              BIETLFOOD,             TRETLFOOD,              SEETLFOOD,
                              CDGRUPSERV,            CDFILISERVFILI,         CDETLFILCENTPME,
                              VRCUSPLACENTFOO,       VRCUSREACENTFOO,        VRCUSPLAFILIFOO,
                              VRCUSREAFILIFOO,       CDTIPOCUSTO)
                           VALUES
                              (@V_CDFILIAL,        @V_CDAREAGERE,       @V_CDSUPERVISOR,
                              @V_CDGOPERAC,       @V_CDEMPRESA,        @V_CDSEGMER,
                              @V_CDPRODUTO,   @V_ANO,                  @V_MES,
                              @V_BIM,                 @V_TRI,                  @V_SEM,
                              @V_CDGRUPSERV,  @V_CDFILIAL+@V_CDSERVFILI,
                              @V_CDFILCENTPME,                 @V_CUSTOPLANCENT,
                              @V_CUSTOREALCENT,            @V_CUSTOPLAN,
                              @V_CUSTOREAL,                @V_CDTIPOCUSTO);

                          SET @V_COUNTER = @V_COUNTER+1;

                          IF @V_COUNTER >= 500 BEGIN
                              COMMIT TRANSACTION;
                              SET @V_COUNTER = 0;
                              BEGIN TRANSACTION;
                          END;
                          FETCH NEXT FROM C_PRODUTO INTO
                  					@V_CUSTOREAL, @V_CUSTOPLAN, @V_CUSTOREALCENT, @V_CUSTOPLANCENT, @V_CDPRODUTO;			
                        END;
                        CLOSE C_PRODUTO;
                        DEALLOCATE C_PRODUTO;

                        INSERT INTO ETL_RESUSERV
                              (CDFILIAL,                  CDAREAGERE,
                              CDSUPERVISOR,              CDGOPERAC,
                              CDEMPRESA,                 CDSEGMER,
                              CDGRUPSERV,                CDFILISERVFILI,
                              CDANOBI,                   CDMESBI,
                              BIETLSERV,                 TRETLSERV,
                              SEETLSERV,                 QTCOMESTETLSERV,
                              QTCOMEFEETLSERV,           VRCUSPADETLSERV )
                           VALUES
                              (@V_CDFILIAL,            @V_CDAREAGERE,
                              @V_CDSUPERVISOR,        @V_CDGOPERAC,
                              @V_CDEMPRESA,           @V_CDSEGMER,
                              @V_CDGRUPSERV,      @V_CDFILIAL+@V_CDSERVFILI,
                              @V_ANO,                     @V_MES,
                              @V_BIM,                     @V_TRI,
                              @V_SEM,                     @V_QTCOMESTICAR,
                              @V_QTCOMEFETCAR,    @V_VRCUSTPADR);

                        SET @V_COUNTER = @V_COUNTER+1;

                        IF @V_COUNTER >= 500 BEGIN
                           COMMIT TRANSACTION;
                           SET @V_COUNTER = 0;
                           BEGIN TRANSACTION;
                        END;
                        FETCH NEXT FROM C_SERVICO INTO @V_CDSERVFILI, @V_CDGRUPSERV, @V_QTCOMESTICAR, @V_QTCOMEFETCAR;
                    END;
                    CLOSE C_SERVICO;
                    DEALLOCATE C_SERVICO;

                    DELETE FROM CONSPLAN
                    WHERE NRCONSPLAN = @V_CDSEQUENCIAL;
                 end;
                 FETCH NEXT FROM C_ETL INTO
                             @V_CDFILIAL,      @V_CDAREAGERE,  @V_DTINICIALBI,
                             @V_CDSUPERVISOR,  @V_CDGOPERAC,   @V_CDEMPRESA,
                             @V_CDSEGMER, @V_CDFILCENTPME;

               END;
               CLOSE C_ETL;
               DEALLOCATE C_ETL;

               COMMIT TRANSACTION;
               SET @V_DTINI = DATEADD(MM, 1, @V_DTINI);
               BEGIN TRANSACTION;
            END;
        FETCH NEXT FROM C_NRTPCUS INTO @V_CDTIPOCUSTO, @V_NRTIPOCUSTO;
      END ;/* end C_NRTPCUS*/
      CLOSE C_NRTPCUS;
      DEALLOCATE C_NRTPCUS;
   END;/* end if*/
END;
GO
-- VERSAO --
EXEC ATUVEROBJ 'ETL_MERENDA','5.11.090';


