var Fis00200_DocumentoDeArrecadacao_Service = function(Messages_fiscal, ScreenService, General) {

	// Configuração dos campos e dataset da widget (para guia apuração ou documento)
	var configFields = [{
			"name": "DTINIPERIODO",
			"A": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			},
			"D": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			}
		},
		{
			"name": "DTFIMPERIODO",
			"A": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			},
			"D": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			}
		},
		/*{
			"name": "VRTOTAL",
			"A": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			},
			"D": {
				"name": "VRTOTAL",
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			}
    	},*/

		{
			"name": "CDNATUREZA",
			"A": {
				"isVisible": true,
				"readOnly": false,
				"validations": {
					"required": true
				}
			},
			"D": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			}
		},


		{
			"name": "CDRECEITA",
			"A": {
				"isVisible": true,
				"readOnly": false,
				"validations": {
					"required": true
				}
			},
			"D": {
				"isVisible": true,
				"readOnly": false,
				"validations": {
					"required": true
				}
			}
		},
		{
			"name": "NMMAPAAPUR",
			"A": {
				"isVisible": true,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			}
		},
		{
			"name": "IDBLOQMAPAPU",
			"A": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			},
			"D": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			}
		},
		{
			"name": "IDTIPOGUIA",
			"A": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "FILIAL_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "NMFILIAL_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "OPERACAO_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "NMDESTEMIT_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "NRNOTAFISC_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "DTENTRSAID_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "DTEMISSAO_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "VRNOTAFISC_DOC",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": true,
				"readOnly": true,
				"validations": {}
			}
		},
		{
			"name": "NRLANCTONFPAG",
			"A": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			},
			"D": {
				"isVisible": false,
				"readOnly": false,
				"validations": {}
			}
		}
	];

	//Função que ajusta a widget parea funcionar como 'Apuração' ou 'Documento', conforme selecionado no filter.
	this.ajustaCamposApuracaoOuDocumento = function(id, widget) {
		var field;

		for (var i = 0; i < configFields.length; ++i) {
			field = widget.getField(configFields[i].name);

			field.isVisible = configFields[i][id].isVisible;
			field.readOnly = configFields[i][id].readOnly;
			field.validations = configFields[i][id].validations;
		}
	};



	/*VALIDAÇÕES GERAIS********************************************************/

	this.validaPreparacaoPagamento = function(dadosPagamento, row) {
		if (!row.DTVENCIMENTO)
			return Messages_fiscal.VENCIMENTO_PAGAMENTO;

		if (row.SGESTADO === 'RJ' && row.IDORGARRECADNFE === 'E') {
			if (!row.CDNATUREZA)
				return Messages_fiscal.NATUREZA_RJ;
		}
		else if (row.SGESTADO !== 'RJ') {
			if (row.CDIMPOSTO != 'SN') { //Para Simples Nacional 
				if (!row.CDRECEITA)
					return Messages_fiscal.CDRECEITA_PAGAMENTO;
			}
		}

		if (!dadosPagamento.CDFILIAL)
			return Messages_fiscal.UNIDADE_PAGAMENTO;

		return true;
	};

	this.validaEmiisaoGuia = function(row) {

		if (!row.DTVENCIMENTO) {
			return Messages_fiscal.VENCIMENTO_PAGAMENTO;

		}

		if (row.SGESTADO === 'RJ' && row.IDORGARRECADNFE === 'E') {
			if (!row.CDNATUREZA)
				return Messages_fiscal.NATUREZA_RJ;

			if (row.IDTRANSMISSAO !== 'E' && row.IDTRANSMISSAO !== 'S')
				return Messages_fiscal.LOTE_INVALIDO;

		}
		else {
			if (!row.CDRECEITA)
				return Messages_fiscal.CDRECEITA_PAGAMENTO;
		}
		if ((row.NRLANCTONFPAG && row.NRLANCTONFPAG != '') ||
			(row.CDFILIALPAG && row.CDFILIALPAG != '')) {
			return ScreenService.showMessage('Preparação de Pagamento já realizada. Desfaça a preparação de pagamento antes de emitir a guia.');
		}

		return true;

	};

	this.validaTransmissaoLoteRj = function(rows) {
		var dtVencimento = false;
		var cdnatureza = false;
		var dtPagamento = false;

		rows.forEach(row => {
			if (!row.DTVENCIMENTO)
				dtVencimento = true;

			if (!row.CDNATUREZA)
				cdnatureza = true;

			if (!row.DTLIMITEPAG)
				dtPagamento = true;

		});

		if (dtVencimento)
			return Messages_fiscal.VENCIMENTO_PAGAMENTO;
		else if (cdnatureza)
			return Messages_fiscal.NATUREZA_RJ;
		else if (dtPagamento)
			return Messages_fiscal.LIMITE_PAGAMENTO;
		else
			return true;
	};

	this.preparaRow = function(row) {
		var ignoredKeys = ["__rightActions", "__leftActions", "_children", "_parent", "__groupHeaders", "__index", "__isSelected", "__notSelectable", "$$hashKey"];
		// Verifica se é um array de rows;
		if (Array.isArray(row)) {
			var rows = [];
			row.forEach(function(linhaSelecionada) {
				rows.push(Util.clone(linhaSelecionada, ignoredKeys));
			});
			return rows;
		}
		else {
			return Util.clone(row, ignoredKeys);
		}

	};

	//Valida se todos os campos necessários para a GNRE TXT estão preenchidos
	this.validaCamposGnreTxt = function(rows, estado) {
		//Verifica se houve seleção de row
		if (rows.length == 0) {
			ScreenService.showMessage(Messages_fiscal.SELECIONE_LINHAS);
			return false;
		}

		//Verifica se houve seleção de 50 ou mais rows
		if (rows.length > 50) {
			ScreenService.showMessage(Messages_fiscal.LIMITE_LINHAS_GNRE);
			return false;
		}

		//Verifica se demais campos obrigatórios forma preenchidos
		for (var i = 0; i < rows.length; ++i) {
			if (!rows[i].DTVENCIMENTO) {
				ScreenService.showMessage(Messages_fiscal.VENCIMENTO_PAGAMENTO);
				return false;
			}
			if (!rows[i].DTLIMITEPAG) {
				ScreenService.showMessage(Messages_fiscal.LIMITE_PAGAMENTO);
				return false;
			}
			if (estado === 'RJ') {
				if (!rows[i].CDNATUREZA) {
					ScreenService.showMessage(Messages_fiscal.NATUREZA_RJ);
					return false;
				}
			}
			else {
				if (!rows[i].CDRECEITA) {
					ScreenService.showMessage(Messages_fiscal.CDRECEITA_PAGAMENTO);
					return false;
				}
			}
			if ((rows[i].NRLANCTONFPAG && rows[i].NRLANCTONFPAG !== '') ||
				(rows[i].CDFILIALPAG && rows[i].CDFILIALPAG !== '')) {
				ScreenService.showMessage('Preparação de Pagamento já realizada. Desfaça a preparação de pagamento antes de emitir a guia.');
				return false;
			}
		}
		return true;
	};



	/*UTILIDADES***************************************************************/

	//Retorna um nome de arquivo a data e hora no formato NOME_AAAAMMDD_HHMMSS.TXT conforme os parametros nomeArquivo, separador e extensao
	this.nomeArquivoDatetime = function(nomeArquivo, separador, extensao) {
		var hoje = new Date();
		return (
			nomeArquivo + separador +
			hoje.getFullYear().toString() +
			(hoje.getMonth() + 1).toString().padStart(2, '0') +
			hoje.getDate().toString().padStart(2, '0') +
			separador +
			hoje.getHours().toString().padStart(2, '0') +
			hoje.getMinutes().toString().padStart(2, '0') +
			hoje.getSeconds().toString().padStart(2, '0') +
			'.' + extensao
		);
	};

	//Funções necessárias para retornar parâmetros necessário para gerar a DARF no servidor da Receita
	this.DataHoraFim = function(h, m, s) {
		var oneSecond = 1000;
		var oneMinute = 60 * oneSecond;
		var oneHour = 60 * oneMinute;
		var dataHoraInvertida, dataInvertidaDia, dataInvertidaMes, dataInvertidaAno, dataInvertidaHora, dataInvertidaMinuto, dataInvertidaSegundo;
		var dataAtual = new Date();

		var dataInMS = dataAtual.getTime();
		dataInMS = dataInMS + oneHour * h + oneMinute * m + oneSecond * s;

		dataAtual.setTime(dataInMS);

		dataInvertidaDia = FormataDataHora(dataAtual.getDate());
		dataInvertidaMes = FormataDataHora(dataAtual.getMonth() + 1);
		dataInvertidaAno = dataAtual.getYear();
		dataInvertidaHora = FormataDataHora(dataAtual.getHours());
		dataInvertidaMinuto = FormataDataHora(dataAtual.getMinutes());
		dataInvertidaSegundo = FormataDataHora(dataAtual.getSeconds());

		dataHoraInvertida = dataInvertidaAno.toString() + dataInvertidaMes.toString() + dataInvertidaDia.toString() + dataInvertidaHora.toString() + dataInvertidaMinuto.toString() + dataInvertidaSegundo.toString();

		return dataHoraInvertida;
	};

	function FormataDataHora(x) {
		var valor = "0" + x;
		var ValorF = String(valor);
		ValorF = ValorF.substr(ValorF.length - 2, 2);
		return ValorF;
	}



	/*DIRECIONAMENTO DE EMISSÃO DE GUIAS PARA OS SITES / BIRT******************/

	this.AcessaSiteGnreSp = function() {
		window.open('https://www.fazenda.sp.gov.br/guiasinternet/Gare/Paginas/Gare.aspx', '_blank');
	};

	//Emissão das guias pelo sistema (birt)
	/*this.EmiteGuiaGnreSp = function(widget, row) {
	    //Para garantir que a DOCARRECADPAG está atualizada para a emissão da GRPR
	    General.callRestEngine('fis_guias#/salvarEdicaoGuia', 'Row', this.preparaRow(widget.currentRow)).then(
	        function(response) {
	            //Atualização do nrseqdocarrecad da row para a correta emissão do relatório
	            row.NRSEQDOCARRECAD = response.dataset.nrseqdocarrecad[0];
	            //Emissão da guia DAEMS via birt
	            General.openReport('fis_guias#/emissaoGuiaBirt', 'gnre-sp', row);
	        },
	        function (callback) {
	            if (callback.data) {
	                ScreenService.showMessage(callback.data.error);
	            }
	        }  
	    );
    };*/

	//Emissão de guia via site da fazenda ou via birt (sistema)
	this.emitirGuia = function(widget, row, message, reportName, urlSite) {
		var preparaRow = this.preparaRow;

		var abrirSiteReceita = function() {
			window.open(urlSite, '_blank');
		};
		var emitirGuiaBirt = function() {
			//Para garantir que a DOCARRECADPAG está atualizada para a emissão da GARE
			General.callRestEngine('fis_guias#/salvarEdicaoGuia', 'Row', preparaRow(widget.currentRow)).then(
				function(response) {
					//Atualização do nrseqdocarrecad da row para a correta emissão do relatório
					row.NRSEQDOCARRECAD = response.dataset.nrseqdocarrecad[0];
					//Emissão da guia GARE via birt
					General.openReport('fis_guias#/emissaoGuiaBirt', reportName, row);
				},
				function(callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				}
			);
		};

		//Se não houver mensagem a função irá abrir o site ou emitir o relatório birt diretamente
		if (message != null) {
			//Questiona se deve abrir o site ou o relatório birt
			ScreenService.confirmMessage(message, "question").then(
				abrirSiteReceita,
				emitirGuiaBirt);
		}
		else {
			//Verifica se abrirá, sem questionar, o site ou o relatório
			if (reportName != null) {
				emitirGuiaBirt();
			}
			else {
				abrirSiteReceita();
			}
		}
	};

	//Emissão da guia DARF via sistema da receita, caso a guia esteja vencida este encaminha para o site/birt
	this.guiaDarfReceitaOuBirt = function(widgetGuia, widget, row, filteredData) {
		var preparaRow = this.preparaRow;
		var multiRows = widget.getCheckedRows();

		//Emissão simples
		//Faz a emissão da DARF via sistema da receita caso esta esteja vencida
		var emitirViaReceita = function(response) {
			if (response.dataset.relatorio[0].resultado) {
				//Gera a DARF via Receita
				window.open("about:blank", "_blank").document.write(response.dataset.relatorio[0].relatorio);
			}
			else {
				ScreenService.showMessage(Messages_fiscal.RELATORIO_NAO_ENCONTRADO);
			}
		};

		//Questiona o usuário se deseja emitir a guia vencida via site da Receita ou via Birt
		var emitirViaReceitaOuBirt = function(callback) {
			if (callback.data) {
				//Verifica se a guia está vencida
				if (callback.data.errorCode == 1) {
					ScreenService.confirmMessage(callback.data.error, "question").then(
						//Questiona se deve gerar a DARF via sistema da receita ou relatório birt
						function() {
							window.open("http://www.receita.fazenda.gov.br/Aplicacoes/ATSPO/SicalcWeb/default.asp?TipTributo=2&FormaPagto=1", "_blank");
						}, emitirViaBirt);
				}
			}
		};

		//Faz a emissão via Birt
		var emitirViaBirt = function() {
			//Para garantir que a DOCARRECADPAG está atualizada
			General.callRestEngine('fis_guias#/salvarEdicaoGuia', 'Row', preparaRow(widget.currentRow)).then(
				function(response) {
					//Atualização do nrseqdocarrecad da row para a correta emissão do relatório
					row.NRSEQDOCARRECAD = response.dataset.nrseqdocarrecad[0];
					//Emissão da guia DARF via birt
					General.openReport('fis_guias#/emissaoGuiaBirt', 'darf', row);
				},
				function(callback) {
					if (callback.data) {
						ScreenService.showMessage(callback.data.error);
					}
				}
			);
		};

		//Emissão múltipla
		var promises = []; //Armazena todas as requisições das guias
		var i;
		var aux;

		//Faz a emissão via Birt de múltiplas guias
		var emitirViaBirtMult = function() {
			//Percorre as rows selecionadas validando e montando os parâmetros para a emissão da guia
			aux = [];

			for (i = 0; i < multiRows.length; ++i) {
				//Monta array de NRSEQDOCARRECAD selecionados
				aux.push(multiRows[i].NRSEQDOCARRECAD);
			}
			//monta row com as opções 
			row = { "NRORG": multiRows[0].NRORG, "NRSEQDOCARRECAD": aux.join(',') };

			//Emissão da guia DARF via birt
			General.openReport('fis_guias#/emissaoGuiaBirt', 'darf', row);
		};

		//Recolhe o conteúdo de todas as guias
		var promiseResolve = function(response) {
			for (i = 0; i < response.length; ++i) {
				window.open("about:blank", "_blank").document.write(response[i].dataset.relatorio[0].relatorio);
			}
		};

		//Sinaliza erro, provavelmente guia vencida
		var promiseReject = function(response) {
			ScreenService.confirmMessage(Messages_fiscal.GUIAS_VENCIDAS_SITE_BIRT, "question").then(
				function() {
					window.open("http://www.receita.fazenda.gov.br/Aplicacoes/ATSPO/SicalcWeb/default.asp?TipTributo=2&FormaPagto=1", "_blank");
				}, emitirViaBirtMult);
		};

		//Verifica se é emissão simples ou múltipla
		if (multiRows.length < 2) {
			//Emissão simples
			General.callRestEngine('fis_guias#/emitirGuia', 'Row', this.preparaRow(widgetGuia.currentRow)).then(
				emitirViaReceita, //Emitirá o documento pelo site caso não esteja vencida
				emitirViaReceitaOuBirt //Se estiver vencida poderá ser emitida via formulário do site ou por relatório birt
			);
		}
		else {
			//Emissão múltipla
			for (i = 0; i < multiRows.length; ++i) {
				aux = this.preparaRow(multiRows[i]);
				//Valida datas e códigos necessários
				if (!multiRows[i].DTVENCIMENTO) {
					ScreenService.showMessage(Messages_fiscal.VENCIMENTO_PAGAMENTO);
					return;
				}
				if (!multiRows[i].CDRECEITA) {
					ScreenService.showMessage(Messages_fiscal.CDRECEITA_PAGAMENTO);
					return;
				}
				//Inclusão de informações do filtro
				aux.CDMUNICIPIO = filteredData.CDMUNICIPIO;
				aux.SGESTADO = filteredData.SGESTADO;
				aux.IDTIPOEMISSAO = filteredData.IDTIPOEMISSAO;
				aux.CDINSCESTA = filteredData.CDINSCESTA;
				aux.CDINSCMUNI = filteredData.CDINSCMUNI;
				aux.IDORGARRECADNFE = filteredData.IDORGARRECADNFE;
				aux.UFFAVORECIDO = filteredData.UFFAVORECIDO;
				aux.OPCGUIA = filteredData.OPCGUIA;
				aux.CDIMPOSTO = filteredData.CDIMPOSTO;
				promises.push(General.callRestEngine('fis_guias#/emitirGuia', 'Row', aux));
			}
			Promise.all(promises).then(
				promiseResolve,
				promiseReject);
		}
	};
};

Configuration(function(ContextRegister) {
	ContextRegister.register('Fis00200_DocumentoDeArrecadacao_Service', Fis00200_DocumentoDeArrecadacao_Service);
});
